write direct -1,7

.plus 		equ memory(#c002) = 7  ;; A word (normal is 0005, Plus is 0007)

.DEF_DDB        equ DDB_B_80_TRACK + DDB_B_DOUBLE_SIDE
.DEF_DPB        equ #00
;.DEF_DPB        equ DPB_ELECTRO

nolist
read "pdos_defs.asm"
;nocode
read "firmware.asm"
read "keys.asm"

limit #ffff

; Make Command Table Point to PDos rather than CPM ROM (3 extra bytes for jump block)
; The Plus AMSDOS has a Jump at #c072 which normally waits for a key press
; then calls MC_START_PROGRAM with HL = 0. This returns to BASIC
org #c004
dw cmd_table

  org #c072
  jp init_plus
  .cmd_table

if plus
  str "ParaDOS"
else
  str "PDOS"
endif

org disc_setup + 6      ; Step-Rate time
db STEP_RATE

if plus
  org #c1bb
  jp setdrv
  .retset
  org #c61c
  call setdrv2
  org #c79d
  call rttr
  org #cede
  call setup
  org #cae1
  call dmess
  org #c7ef
  pop de
  jp #da3b
else
  org #c1c4
  jp setdrv
  .retset
  org #c5f2
  call setdrv2
  org #c76f
  call rttr
  org #cde7    ; Second call in |DRIVE
  call setup
  org #ca7b
  call dmess
endif

; Common patches
org #c687
call drvhd
org #c566
call drvhd
org #c577
ld hl,(RAM_DPB)
call abstrk
org #c6a6
call rttr2
org #c6aa
call rthd

macro form_def sects, blm, exm, blocks, off, dirs, first
let blk_hi = blocks and #100 / 8
if blm = 5
  let dir_blks = #80
  let blk_hi = blk_hi or #08
elseif dirs = 256
  let dir_blks = #f0
else
  let dir_blks = #c0
endif
db off * 64 + sects, exm * #40 + blk_hi + blm, blocks, dirs / 64 + dir_blks, first
endm

macro ldc addr
  if2
    @d2h equ d2 / 256
    if addr / 256 - @d2h
      print "Error ldc addr: $addr"
      stop
    endif
  endif
  ld c,addr
endm

; The code at #C581 is identical for AMSDOS/Plus
org #c581       ; SELECT_FORMAT routine, E = Drive, A = sector
limit #c5d3
ld hl,(RAM_DPB)
and #f0
jp z,is0x

cp #10		; Ultraform or D10
jp z,is1x

cp #20
ld bc,d2
jr z,dosetdpb

cp #30
ldc d20
jr z,dosetdpb

cp #c0
ldc data40
jr z,goelectro

cp #50
ldc d40
jr z,dosetdpb

cp #70
ldc d80
jr z,dosetdpb

cp #90
ldc pdos80
jr z,dosetdpb

cp #a0
ld bc,pdos40d
jr z,dosetdpb

cp #80
ld bc,pdos41
jr z,dosetdpb

cp #40
ld bc,sys40
.goelectro
jp z,electro

ld bc,unknf
.dosetdpb
jp setdpb

let tmp = #c5d4 - $
ds tmp
if2:print "Space to #C5D4: $tmp":endif

; Reset routine
org dpb_reset
limit origsys40 - 1
ld hl,#0220
ld de,#01d0
call lca03

ld hl,#0210
ld de,#0190

.lca03
ld a,l		; Keep track of drive
call deiyde
ld (#be42),de	; Pointer to DPB for Drive A = IY + #190 = #A890
push de
call hliyhl	; Preserves A
ld (#be40),hl	; Pointer to DPH for Drive A = IY + #210 = #A910
push hl
ex de,hl
sub #10
ld e,a		; E = drive
ld bc,sys40
call setdpbhl
inc hl
ld (hl),b
inc hl
ld (hl),b
inc hl
ld (hl),b
inc hl
ld b,h
ld c,l
pop hl
ld de,7
ld (hl),d	; Skew factor 	
inc hl
ld (hl),d	; Skew factor
add hl,de
ld de,#0230
call deiyde	; DE = IY + #230 (#A930)
ld (hl),e
inc hl
ld (hl),d	; Pointer to directory buffer
inc hl
pop de
ld (hl),e
inc hl
ld (hl),d	; Pointer to DPB (#A890/#A8D0)
inc hl
ld (hl),c	; DPB + #19 Checksum vector
inc hl
ld (hl),b
ret

org origsys40
limit origsys40 + #18
.sys40		form_def 9, 3, 0, #aa, 2, 64, #41
.sys160		form_def 9, 5, 3, #b0, 2, 128, #41
.sys80		form_def 9, 4, 1, #ae, 2, 128, #41

.pdos41		form_def 10, 3, 0, #cc, 0, 64, #81

.ultra		form_def 10, 3, 0, #cc, 0, 64, #10

let tmp2 = origsys40 + #18
let tmp = origsys40 + #19 - $
if2:print "Space to #$tmp2: $tmp":endif

; Non-Plus can put code from #dc00
; Plus only has #dcf7 onwards, but has some space at #cdd7 to #ce5c and we're using
; #cdd7 to #cddf
org rom_empty1
limit limit1
.setdrv2
push hl
ld hl,16
add hl,sp
ld a,(hl)
cp #2e
jr z,ok464
cp #2b
jr nz,nosign
.ok464
inc hl
ld a,(hl)
cp 3
call z,signon

.nosign
ld hl,(RAM_LOCK)
ld a,h
cp #44
jr nz,resetddb
ld a,l
cp #50
jr z,movein
.resetddb
ld hl,(ROM_DPB)
ld (RAM_DPB-2),hl
ld hl,#4450		; "PD"
ld (RAM_LOCK),hl	; #bafa
.movein
ld hl,(RAM_DPB-2)
ld (RAM_DPB),hl
pop hl
;.dob912
jp KL_CURR_SELECTION

.setdrv
call KL_CURR_SELECTION
or a			; If this is ROM 0, do CPM
jr z,c1c7
cp 7			; If this is ROM 7, log on as normal
jr z,c1c7
pop bc			; Return address in lower ROM
ret nc
push bc
push de
push hl
ld hl,3
add hl,bc
ld b,a
ld a,(hl)
inc hl
cp #21
jr z,is464
inc hl
inc hl
.is464
ld e,(hl)
inc hl
ld d,(hl)		; Address of ROM workspace table
ex de,hl

ld de,14		; Offset of ROM 7
add hl,de
ld a,(hl)
inc hl
or (hl)			; Not logged on if zero
ld a,b
jr nz,overwr
pop hl
pop de

.c1c7
push iy
push de
jp retset

.overwr			; Overwrite the ROM workspace of ROM 7
sbc hl,de
ld e,a
add hl,de
add hl,de		; HL=address of workspace table for this ROM

;;push iy
ld de,(AMSDOS_RESERVED)	; Address of Disc ROM workspace
ld (hl),d               ; Set this ROM to use the same workspace
dec hl
ld (hl),e
push de
ex (sp),iy		; IY is the workspace for this and disc ROM
ld (iy-2),a
ld hl,ticker            ; Modify Ticker Event address
ld (TICKER_ADDRESS),hl

if plus
  jp cont_over
  let end1 = $
  let tmp1 = limit1 - end1 + 1
  print "Section 1 end: $end1 ($tmp1)"
  org rom_empty2
  limit #fffd
  .cont_over
endif

ld (TICKER_ROM_SEL),a
ld hl,#18b
call hliyhl             ; Cassette jumpblock RST #18 address
ld (hl),cas_jump
inc hl
ld (hl),cas_jump / 256
inc hl
ld (hl),a
ld hl,disc_setup
call setup_disc
push hl
call setdrv2
pop hl
pop iy
pop hl
pop de
or a
ret

if plus
  .pluschar equ "+"
else
  .pluschar equ " "
endif

.signon
call cprint
db " ",#c6,"V1.2",pluschar,#b0,13,10,10,#ff
ret

.header
db #c6,"- Version 1.2",pluschar," ",#b0,"  Program by Richard Wilson.",#ff

.init_plus
call KL_L_ROM_ENABLE
ld hl,0
jp #77

.nomen	; Clear the menu bar and print something in it
call cprint
db 26,0,79,24,24,14,1,15,0,12," ",#ff	; Set Window 0,79,24,24. Paper 1. Pen 0. Clear Text.

.cprint
pop hl
call cprint2
jp (hl)

.cprint2
push ix
ld ix,TXT_OUTPUT
call fprint3
pop ix
ret

.dprint
push hl		; Used once, no need to push ix
ld ix,fastdh
jr fprint4

.fprint2
push ix
ld ix,fastchr

.fprint4
call KL_L_ROM_ENABLE
call fprint3
call KL_L_ROM_DISABLE
pop ix
ret

.fprint3
ld a,(hl)
inc hl
cp #a5
jr c,lessa5
cp #ff
ret z
cp #fe
jr nz,multf
push bc
ld a,c
cpl
ld c,a
ld a,(hl)
inc hl
call doix
pop bc
jr fprint3

.multf
cp -23
jr nc,gt23
push hl
ld hl,messtab
sub #a5
jr z,gotmess
ld b,a
ld a,#ff
.getmess
cp (hl)
inc hl
jr nz,getmess
djnz getmess

.gotmess
call fprint3
pop hl
jr fprint3

.gt23
jr nz,not23
ld a,-55
.not23
neg
.multf2
ld b,a
ld a,(hl)
inc hl
or a
jr nz,pllop2
.pllop3
inc de
djnz pllop3
jr fprint3

.pllop2
push bc
push af
call doix
pop af
pop bc
djnz pllop2
jr fprint3

.lessa5
call doix
jr fprint3

.fastch
push af
call KL_L_ROM_ENABLE
pop af
call fastchr
jp KL_L_ROM_DISABLE

.fastchr	; C=XOR mask
push hl
ld h,7
ld l,a
add hl,hl
add hl,hl
add hl,hl
ld b,8
.chloop
ld a,(hl)
inc l
xor c
ld (de),a
ld a,d
add b
ld d,a
jr nc,chloop
add #c0
ld d,a
pop hl
inc de
ret

.fastdh
push hl
ld h,7
ld l,a
add hl,hl
add hl,hl
add hl,hl
ld b,8
push de
.chrloop
ld a,(hl)
cpl
ld (de),a
ld a,d
add b
ld d,a
ld a,(hl)
cpl
ld (de),a
inc l
ld a,d
add b
jr nc,noadd
ld a,e
cp #50
jr nc,last
add #50
ld e,a
ld a,d
adc #c8
.noadd
ld d,a
jr chrloop

.last
pop de
pop hl
inc de
ret

.chkdrv_e
ld a,e

;Get Drive A DDB or (DPB << 4) in A
.chkdrv_a
push bc
push de
ld e,a
ld bc,#0ff0
ld a,(RAM_DPB)
ld d,a
rra
jr c,nodpbuse2	        ; If Bit 0 of DPB is set, only use the Drive Setup parameter

ld a,b		        ; #0F (first sector from DPB)
call getdrvdpbv
and c

.not0x
cp #90			; PARADOS 80
jr z,is_ss80
cp #70			; S-DOS (ROMDOS D80)
jr nz,not_ss80

.is_ss80
dec b			; Mask to #E (single-sides)
set 1,c			; 80 tracks per side

.not_ss80
cp #80			; PARADOS 41?
jr z,setbtoc		; Must be single sided, 40 track

or a			; IBM/D1/PCW/Vortex
jr nz,notd1a
bit 2,d
jr z,ds80		; Must be D1 or Vortex (DS80)

.notd1a
cp #10			; Ultraform/D10
jr nz,notd10a
bit 3,d			; Ultraform disabled?
jr z,ds80		; Must be D10 (DS80)
jr setbtoc		; If Ultraform (SS40)

.notd10a
bit 1,d			; Electro formats enabled?
jr nz,nodpbuse		; IF not, DATA, SYSTEM and IBM (SS40)

cp #40			; SYSTEM
jr z,setbtoc
cp #c0			; DATA
jr z,setbtoc
or a			; IBM
jr nz,nodpbuse

.setbtoc		; Only consider head and single-step for Electro formats
ld b,#c

.nodpbuse
cp #20			; D2
jr z,ds80
cp #50			; D40
jr z,ds40
cp #a0			; PARADOS 40D
jr z,ds40
cp #30			; D20
jr nz,nodpbuse2

.ds80
set 1,c			; 80 tracks per side
.ds40
set 0,c			; Double sided

.nodpbuse2
call getddb_e		; Get DDB
and b
or c
pop de
pop bc
ret

.getddb_e
ld a,e

.getddb_a
or a
ld a,(RAM_DDB)
jr nz,driveb
rra:rra
rra:rra
.driveb
bit 1,a		; If drive is 40 track, then
ret z		; return
and #7		; else Disable double-stepping
ret

.is0x
bit 4,l		; Vortex/PCW
jr nz,vortpcw
bit 2,l		; Bit set for IBM, else D1
ld bc,ibm40
jr nz,electro
ld bc,d1
jr setdpb

.is1x
ld bc,d10
bit 3,l
jr z,setdpb
ld bc,ultra
jr setdpb

.vortpcw
bit 2,l
ld bc,vortex
jr z,setdpb
ld bc,pcw40	  ; Order needs to be pcw40, pcw160, pcw40!!

.electro	  ; Order of formats is 40, 160, 80
bit 1,l		  ; Electro formats enabled
jr z,setdpb	  ; If not, use 40 track format
call getddb_e
and 3
jr z,setdpb
ld hl,5
cp 3
jr z,setelectro 
add hl,hl
.setelectro
add hl,bc
ld b,h
ld c,l

.setdpb
xor a
call getdrvdpb	; Get DPB in HL

.setdpbhl
push de
ld e,0		; Drive no longer available
ld a,(bc)	; Sectors per track (Bits 6 and 7 are OFF (reserved tracks))
inc bc
ld d,a
add a:add a
ld (hl),a
inc hl
ld (hl),e	; 0
inc hl
ld a,(bc)
and #0f		; BLM (3, 4 or 5)
ld (hl),a
res 3,(hl)
inc hl
add a
or #07		; -> (7, F or 1F)
ld (hl),a
inc hl
ld a,(bc)	; Bit 7 is (0 or 1) EXM
inc bc
and #e0
rla:rla:rla	; Bit 5 (blocks high byte) into Carry
ld (hl),a
inc hl
ld a,(bc)
inc bc
ld (hl),a
push af		; AF currently has Carry as block high-byte and A is blocks low-byte
inc hl
ld a,e		; Zero
rla		; Get blocks high byte
ld (hl),a
inc hl
ld a,(bc)	; Dirs / 64
rrca
rrca
and #c0
dec a
ld (hl),a	; Dirs - 1
inc hl
ld (hl),e	; 0
inc hl
ld a,(bc)
inc bc
and #f0
ld (hl),a	; Dir mask
inc hl
ld (hl),e	; 0
inc hl
ld a,(bc)
add a:add a
add a:add a
and #70
ld (hl),a	; CKS
inc hl
ld (hl),e	; 0
inc hl
ld a,d
rlca:rlca
and #03
ld (hl),a	; OFF (reserved tracks)
inc hl
ld (hl),e	; 0
inc hl
ld a,(bc)
ld b,e		; B = 0, Used to remove 2 bytes from reset routine
ld (hl),a	; First sector
inc hl
ld a,d
and #3f		; Sectors per track
ld (hl),a
inc hl
ld de,#2a52	; 9 sectors
cp 9		
jr z,gotspt
ld e,#50	; 8 sectors
jr c,gotspt
ld de,#0910	; 10 sectors
.gotspt
ld (hl),d
inc hl
ld (hl),e
inc hl
ld (hl),#e5
inc hl
ld (hl),#02
inc hl
ld (hl),#04
pop af
ex (sp),hl	; Drive in L

jr c,bigalv
cp #b8
jr c,stdalv

; Big ALV select (used for Ultraform, ParaDOS 41, ALL ROMDOS formats) require up to #32 (50) bytes
.bigalv
ld a,l
or a
ld de,#be00	; #BE00..#BE31
jr z,setalv
ld de,#4b0	; IY+#4B0 (#ABB0..#ABE2)
jr isalva

; Standard ALV select (normally 23 bytes * 8 bits = 184 bits)
.stdalv
ld a,l
ld de,#1b9
or a		; For Drive A?
jr z,isalva
ld e,#f9
.isalva
call deiyde	; DE = Address of standard ALV for the drive (IY + #1B9/#1F9) (#A8B9/A8F9) (64 bytes?)
.setalv
ld hl,#21e
or a
jr z,isalva2
ld l,#2e
.isalva2
call hliyhl	; HL = Address of ALV variable for the drive (IY + #21E/#22E) (#A91E/#A92E)
ld (hl),e
inc hl
ld (hl),d
pop hl
scf
ret

.drvhd
call chkdrv_a
push bc
ld b,a
bit 0,b		; Double-Sided?
ld a,e
jr z,single
bit 0,d		; If so and track and 1 <> 0
jr z,output
set 2,a		; Use Head 1
.output
pop bc
.dofdc
jp fdc_out

.single
ld a,b
and 4
or e
jr output

; Modifies D to suit sided-ness and double-step
; Only called from a single spot with A=#17 (DPB alignment flag location returned in HL)
; This routine does NOT have to preserve A!!!
; Plus ROM doesn't preserve DE
.rttr
if plus
  pop hl
  push de
  push hl
endif
call getdrvdpb	; Get appropriate address in HL
call chkdrv_e
rra		; Carry if double-sided
jr nc,output2
srl d		; Divide by 2 if double-sided
.output2
bit 2,a		; Double-step?
ret z
sla d		; Multiply by 2 if so
ret

; Ouput correct cylinder based on format and track
; Entry A = D = track, E = drive, BC=#FB7E
; Does NOT have to preserve A
.rttr2
call chkdrv_e
push bc
ld b,a
bit 0,b
ld a,d
jr z,output
srl a
jr output

.rthd
call chkdrv_e
and 1		; Double-sided
jr z,dofdc	; No, output head 0
ld a,d
and 1		; Use track and 1
jr dofdc

; abstrk is used to????
.abstrk
push hl
set 0,l			; Lock - don't use format
res 0,h			; DDB Bit 0 (not double-sided B)
res 4,h			; (or A)
ld (RAM_DPB),hl
ld hl,scan_cyl		; C55D
call withretry
push af
ld hl,FDC_BUFF_ST0
bit 6,(hl)
jr z,nodefsec
ld l,FDC_BUFF_R
ld (hl),UNUSED_SECTOR
.nodefsec
pop af
pop hl
ld (RAM_DPB),hl
ret

.pcw40		form_def 9, 3, 0, #ae, 1, 64, #01

.pcw160		form_def 9, 4, 0, #164, 1, 256, #01

.ibm40		form_def 8, 3, 0, #9b, 1, 64, #01
.ibm160		form_def 8, 5, 3, #9e, 1, 128, #01
.ibm80		form_def 8, 4, 1, #9d, 1, 128, #01

.data40		form_def 9, 3, 0, #b3, 0, 64, #c1
.data160	form_def 9, 5, 3, #b3, 0, 128, #c1
.data80		form_def 9, 4, 1, #b3, 0, 128, #c1

.vortex		form_def 9, 5, 3, #b0, 2, 128, #01

.d1		form_def 9, 4, 0, #167, 0, 128, #01

.d2		form_def 9, 4, 0, #167, 0, 256, #21

.d10		form_def 10, 4, 0, #18f, 0, 128, #11

.d20		form_def 10, 4, 0, #18f, 0, 256, #31

.d40		form_def 10, 4, 0, #c7, 0, 128, #51

.d80		form_def 10, 4, 0, #c7, 0, 128, #71 ; Old SDOS format

.pdos80		form_def 10, 4, 1, #c7, 0, 128, #91

.pdos40d	form_def 10, 4, 1, #c7, 0, 128, #a1

.unknf		form_def 8, 3, 0, #01, 0, 64, UNUSED_SECTOR		

macro scr_addr reg,x,y,base
  if "base" = ""
    @bs equ #c000
  else
    @bs equ base
  endif
  ld reg,y * 80 + x + @bs
endm

.dmess
ld a,(iy+0)
inc a
ld a,(DISC_ERR_FLAG)
ret nz
pop af
pop af
push bc
push hl
push de
push af
call TXT_GET_WINDOW
ld (oldwin),hl
ld (oldwin+2),de
call TXT_GET_CURSOR
ld (oldcurs),hl
call TXT_GET_PEN
ld (oldpen),a
pop af
push af
cp #12
scr_addr hl,12,10
ld bc,#1cff
jr nz,smallwin
scr_addr l,9,10
ld b,#22
.smallwin
ld (wintop),hl
push bc
push hl
inc b
inc b
ld a,b
ld (winwid),a
ld a,ramldir
call winrout5
pop de
pop bc
call tline
ld a,3
call mhline
call bline
ld a,27
rrc b
dec b
sub b
ld h,a
ld a,27
add b
ld d,a
ld l,11
ld e,#d
call TXT_WIN_ENABLE
xor a
call TXT_SET_PEN
ld a,1
call TXT_SET_PAPER
pop af
pop de
pop hl
pop bc
ld c,e
call retigncan
push af
push hl
push de
push bc
ld hl,(wintop)
ld a,(winwid)
ld b,a
ld a,ramexldir
call winrout5
ld hl,(oldwin)
ld de,(oldwin+2)
call TXT_WIN_ENABLE
ld a,(oldpen)
ld b,a
call TXT_SET_PEN
ld a,b
xor 1
call TXT_SET_PAPER
ld hl,(oldcurs)
call TXT_SET_CURSOR
pop bc
pop de
pop hl
pop af
ret

.bline
ld hl,#9a99     ; Chars 
ld a,#93        ; Char 
jr hline

.mhline
push af
call hline2
pop af
dec a
jr nz,mhline
ret

.tline
ld hl,#9a9c     ; Chars 
ld a,#96        ; Char 
jr hline

.hmline4
ld a,4
.hmlinea
call mhline

.mline
ld hl,#9a9d     ; Chars 
ld a,#97        ; Char 
jr hline

.hline2
ld hl,#2095     ; Chars  
ld a,l

.hline		;B=width, A=left character, H=mid character, L=right character
push de
push bc
call fastch
call KL_L_ROM_ENABLE
pop bc
push bc
res 7,b
.mloop
push bc
ld a,h
call fastchr
pop bc
djnz mloop
ld a,l
call fastchr
pop bc
pop de
ld hl,80
bit 7,b
jr z,downl
ld hl,-80
.downl
add hl,de
ex de,hl
jp KL_L_ROM_DISABLE

.ctagged
ld hl,(ftagged)
jr chkhl

.clastf
ld hl,(lastf)
.chkhl
ld a,h
or l
ret nz
pop hl
ret

.cursor
call clastf
ld a,(curpos)
call times80
ld a,(curpos+1)
ld c,a
add a		;*2
add a		;*4
add a		;*8
add c		;*9
add a		;*18
ld c,a
add hl,bc
scr_addr bc,1,3
add hl,bc
ld (curadr),hl
ld bc,#1201
.cursdisp
ld a,cdisp
jp winrout

.pad
ld a,e
cp h
ret z
ld a,32
call fastch
jr pad

.dechl_k
srl h:rr l
srl h:rr l
jr dec3

.showbktrk
ld hl,#1601
push af
call TXT_SET_CURSOR
pop af

scr_addr de,17,24

.dec3a
ld l,a
ld h,0
.dec3
ld ix,#20ff
jr dec3b

.dec5		;Display HL as a 5 digit decimal
ld hx,32
ld bc,10000
call decbit
ld bc,1000
call decbit

.dec3b
ld bc,100
call decbit
ld bc,10
call decbit
ld a,l
add 48
jr decdig

.decbit
ld a,"0"
or a
sbc hl,bc
jr c,fnddig
inc a
ld hx,"0"
jr decbit+2
.fnddig
add hl,bc
cp "0"
jr nz,decdig
ld a,hx
.decdig
ld c,lx
jp fastch

.times80
add a	;*2
add a	;*4
add a	;*8
ld l,a
ld c,a
ld h,0
ld b,h
add hl,hl	;*16
add hl,hl	;*32
add hl,bc	;*40
add hl,hl	;*80
ret

.getblk		;HL=block number, drive in A, returns L=track, H=sector
ld e,a
ld a,2
call getdrvdpbv ;Get block shift in A
sub 2
.adjhl
add hl,hl	;HL=HL*sectors per block
dec a
jr nz,adjhl
ld a,#10
call getdrvdpbv	;Get sectors per track in A
push de
ld c,a
ld de,0
ld b,d
ld a,16
.loopd
push af
add hl,hl
rl e
rl d
ex de,hl
call cphlbc
jr c,nodiv
sbc hl,bc
set 0,e
.nodiv
ex de,hl
pop af
dec a
jr nz,loopd
ld h,e
pop de
ld a,(resert)
add l
ld l,a
ld a,(sect2)
add h
ld h,a
ret

.checkused
ld a,(bufstbk)
ld l,a
ld a,(bufendbk)
cp l
ret nz
ld hl,(bufstrt)
ld bc,(bufend)
jr cphlbc

.getfree		; Get Buffer Free bytes in AHL
ld a,(buffree+2)
ld hl,(buffree)
or a
ret

.checkfree		; Check if Buffer has room for BC bytes (NC if so)
call getfree
ret nz

.cphlbc
ld a,h
sub b
ret nz
ld a,l
sub c
ret

.rbuff
push hl
push bc
call movout
ld (bufstrt),de
ld (bufstbk),a
call getfree
pop bc
push bc
add hl,bc
adc 0
call setfree
pop bc
pop hl
ld de,winbuff
.outbuff
ex de,hl
ldir
ex de,hl
ret

.inbuff
ldir
ret

.wbuff
push bc
push bc
ld de,winbuff
ldir
pop hl
call movin
ld (bufend),de
ld (bufendbk),a
pop bc
call getfree
sbc hl,bc
sbc a,0
.setfree
ld (buffree),hl
ld (buffree+2),a
jp showfree

.movout
ld h,b:ld l,c
push hl
ld de,(bufstrt)
add hl,de
ld a,(bufstbk)
ld ix,outbuff
jr movemem

.movin
push hl
ld de,(bufend)
add hl,de
ld a,(bufendbk)
ld ix,inbuff

.movemem
ld bc,#8000
cp b
jr nz,usea3
ld b,#a3
.usea3
or a
sbc hl,bc
jr nc,nofit
pop bc		;Total length

.fits
ld hl,winbuff
push hl
push bc
ld h,#be
ld l,a
ld b,#7f
ld c,(hl)
out (c),c
pop bc
ld a,b
or c
ld a,l
pop hl
call nz,doix
ld bc,#7fc0
out (c),c
ret

.doix
jp (ix)

.nofit
ex (sp),hl		;Second section length
ld h,b
ld l,c
sbc hl,de
ld b,h
ld c,l
call fits
ld d,#40
inc a
pop bc
jr fits+3

.messtab
db #fe,"Attributes",-3," ",#fe,"Copy",-3," "	;#A5
db #fe,"E",#bf,-3," ",#ff
db "  ",#fe,"Tag",-3," ",#fe,"Un-tag",#ff	;#A6
db "ser number",#c0,#ff				;#A7
db "Total ",#ff					;#A8
db "entries ",#ff				;#A9
db "space  ",#ff				;#AA
db "agged ",#ff					;#AB
db "buffer  ",#ff				;#AC
db "rive ",#ff					;#AD
db "ormat",#ff					;#AE
db "erify",#ff					;#AF
db " ",#a4,"2015 BitWise Systems.",#ff		;#B0
db "ead only",#ff				;#B1
db "Used ",#ff					;#B2
db "Free ",#ff					;#B3
db "iles",#ff					;#B4
db "isc ",#ff					;#B5
db "d",#b5,#ff					;#B6	; disc 
db #b6,#cb,#ff					;#B7
db " ",#cb,#ff					;#B8
db "rror",#ff					;#B9
db "ress any key",#ff				;#BA
db #d8,"track",#c0,#ff				;#BB  ; ing track ; 
db ":  0K",#ff					;#BC
db "ename ",#ff					;#BD
db "irectory ",#ff				;#BE
db "rase",#ff					;#BF
db " : ",#ff					;#C0
db #dc,"Ok",-3," ",#ff				;#C1

db "ROMDOS D",#ff				;#C2
db "SYSTEM ",#ff				;#C3
db "DATA ",#ff					;#C4
db "IBM ",#ff					;#C5
db "ParaDOS ",#ff				;#C6
db "(S",#cc,#ff					;#C7
db "(D",#cc,#ff					;#C8
db "(S",#cd,#ff					;#C9
db "(D",#cd,#ff					;#CA

db "to ",#ff					;#CB
db "S 40)",#ff					;#CC
db "S 80)",#ff					;#CD

db "setup ",#ff					;#CE
db "onfigure ",#ff				;#CF

db "ULTRAFORM",#ff				;#D0

db "orted)",#ff					;#D1
db "(Y/N)",#c0,#ff				;#D2
db " another ",#b6,#ff				;#D3

db "VORTEX ",#ff				;#D4
db "PCW ",#ff					;#D5
db "F",#ae,"s",#ff				;#D6
db "ackup",#ff					;#D7

db "ing ",#ff					;#D8
db "Read",#ff				        ;#D9
db "Writ",#ff				        ;#DA
db "Insert ",#ff				;#DB
db " - ",#ff					;#DC

; Can't use from -23 (DD)

.setup
or a
jp nz,org_drive
ld hl,ramcode
ld de,ramaddr
ld bc,endcurs-ramcode
ldir
call KL_CURR_SELECTION
ld hl,ramaddr + 1
ld (hl),a
dec hl
;ld c,0		; C already 0 from LDIR KL_CURR_SELECTION preserves
jp MC_START_PROGRAM

.nextram
ld a,c
cp #c1
jr c,set2	; Only #C0 will set carry
inc c
.set2
set 2,c
ret nz
ld c,#c0
ret

.begun
ld iy,#ac00
ld (iy+0),#ff
ld hl,#4000
ld de,ramlist
ld bc,#7fc0
ld ix,#62
.ramcheck
out (c),c
ld (hl),l
call nextram
jr nz,ramcheck
.ramcheck2
out (c),c
ld a,(hl)
or a
jr nz,nogood
cpl
ld (hl),a
ld a,c
ld (de),a
inc de
ld a,lx
add h		; #40
ld lx,a
jr nc,nogood
inc hx
.nogood
call nextram
jr nz,ramcheck2
xor a
ld (de),a
out (c),c
ld e,a
ld a,hx
ld d,lx
ld (buftot),de
ld (buftot+2),a
ld hl,initfs
ld de,fspec
ld bc,14+13+4+4+1+3+2
ldir
call cprint
db 4,2,29,13,13,28,-3,32,28,1,13,13,14,1,15,0
db 26,0,79,0,1,12
db 26,0,79,24,24,12,#ff

ld de,#c002
ld hl,header
ld c,#ff
call dprint

.UnLogDisc
ld sp,#c000
call clmain
xor a
ld h,a:ld l,a
ld (lastf),hl
ld (ftagged),hl
dec a
ld (fspec),a
ld c,a
scr_addr de,0,2
call fprint
db #96,-23,#9a,#9e,-22,#9a,#9c,#ff	; Chars 
ld b,20
.pllop
push bc
call fprint
db #95,-23,0,#95,-22," ",#95,#ff	; Chars       
pop bc
djnz pllop
call fprint
db #93,-23,#9a,#9b,-22,#9a,#99,#ff      ; Chars 
inc c
scr_addr de,57,3
call fprint
db -5," Inf",#ae,"ion",-6," ",#ff	; Information
dec c
scr_addr e,57,5				; Same MSB
call fprint
db "D",#ad,#c0,#ff			; Drive
scr_addr de,57,6
call fprint
db "F",#ae,#c0,#ff			; Format
scr_addr e,57,7                         ; Same MSB
call fprint
db "User",-3," :",#ff
scr_addr e,57,8                         ; Same MSB
call fprint
db "F",#b4," ",#c0,#ff			; Files
scr_addr de,57,10
call fprint
db "No. of f",#b4," ",#c0,#ff           ; No. of files
scr_addr e,57,11			; Same MSB
call fprint
db #b2,#a9,#c0,#ff			; Used entries
scr_addr e,57,12
call fprint
db #a8,#a9,":",#ff			; Total entries
scr_addr de,57,14
call fprint
db #b3,#aa,"  ",#bc,#ff			; Free space ;     0K
scr_addr e,57,15			; Same MSB
call fprint
db #b2,#aa,"  ",#bc,#ff			; Used space ;     0K
scr_addr de,57,16
call fprint
db #a8,#aa," ",#bc,#ff			; Total space ;    0K
scr_addr e,57,18			; Same MSB
call fprint
db "T",#ab,"f",#b4," ",#c0,#ff		; Tagged files
scr_addr de,57,19
call fprint
db "T",#ab,#aa,#bc,#ff			; Tagged space ;   0K
scr_addr e,57,21			; Same MSB
call fprint
db #b3,#ac," ",#bc,#ff			; Free buffer ;    0K
scr_addr de,57,22
call fprint
db #a8,#ac,#bc,#ff			; Total buffer ;   0K
ld h,1
call setbuff

.keyloop2
ld hl,RAM_DPB
res 0,(hl)
ld a,l		; FE
ld (keystate),a
call status
.keyloop3
call cursor
.keyloop
ld a,KEY_CONTROL
call KM_TEST_KEY
ld hl,klist2
ld a,2
jr nz,pressed
ld a,KEY_SHIFT
call KM_TEST_KEY
ld hl,klist1
ld a,1
jr nz,pressed
ld hl,klist0
xor a
.pressed
push hl
call showmenu
pop hl
call KM_READ_KEY
jr nc,keyloop
call uppercase
ld b,a
.ktloop
ld a,(hl)
inc hl
or a
jr z,testud
cp b
jr z,pressed2
inc hl
inc hl
jr ktloop
.pressed2
call cursor2
ld e,(hl)
inc hl
ld d,(hl)
ex de,hl
call KL_PCHL
.cont
ld sp,#c000
jr keyloop2

.testud
xor a			; ld a,KEY_UP (0)
call KM_TEST_KEY
jr nz,goup
ld a,KEY_DOWN
call KM_TEST_KEY
jr z,keyloop
call cursor3

.godown
ld bc,#213		; Screen position is X=2, Y=19 (3 x 20 files)
call cpbchl
jr nz,notscru

call first		; Get address of first file in HL
ld bc,60
add hl,bc		; Add 60 (3 x 20 files)
call checkhl		; Compare to last file address
jr c,setcurs+3

call mainw		; Set window
db 31,1,21,10,24,#ff	; Locate 1,21 then LF, exchange paper and pen
ld hl,firstf
inc (hl)
call first
scr_addr de,1,22
add 19

.showem
ld l,a
call showf
inc de
call showf
inc de
call showf
jr setcurs+3

.notscru
ld a,d
cp h
jr nz,notr1
ld a,l
cp e
jr z,setcurs+3
.notr1
ld a,l
inc a
ld l,a
cp 20
jr nz,setcurs
ld l,0
inc h
.setcurs
ld (curpos),hl
jp keyloop3

.goup
call cursor3
ld a,h
or l
jr nz,notscrd
ld hl,firstf
ld a,(hl)
or a
jr z,setcurs+3
dec (hl)
call mainw
db 11,10,24,#ff
call first
scr_addr de,1,3
jr showem

.notscrd
ld a,l
dec l
or a
jr nz,setcurs
ld l,19
dec h
jr setcurs

.mainw
call cprint
db 26,1,55,3,22,24,#ff		; Set window 1,55,3,22 (l,r,t,b)
jp cprint

.cursor3
call cursor
ld hl,(curpos)
ld de,(maxcp)
ret

.cursor2
push hl
call cursor
.ret0
pop hl
xor a
ret

.getkey2
call setxy
call getukey
jr c,ret0
ld c,a
ret

.status
ld c,#ff
scr_addr de,57+8,7
ld a,(fspec + 1)		; All User areas?
or a
jr z,showdecu
call fprint
db "All",#ff
jr notdecu
.showdecu
ld a,(fspec + 2)
call dec3a
.notdecu
scr_addr de,57+8,8
ld hl,fspec2
call fprint2
scr_addr de,57+8,5
ld a,(fspec)
inc a
ret z
add 64
call fastch
call fprint
db ": (",#ff
ld a,(issort)
or a
jr z,itssort
call fprint
db "Un-s",#d1,#ff	; Un-sorted)
jr notsort
.itssort
call fprint
db "S",#d1,#fd," ",#ff	; Sorted)
.notsort
scr_addr de,57+8,6
ld hl,(formdesc)
call fprint2
.nochar
ld h,#2f
call pad
scr_addr de,57+15,10
ld hl,(files)
call dec3
scr_addr de,57+15,11
ld hl,(entries)
call dec3
scr_addr de,57+15,12
ld a,(dire)
ld l,a
ld h,0
inc hl
call dec3
ld hl,(totalk)
push hl
ld de,(kused)
or a
sbc hl,de
scr_addr de,57+15,14
call dec3
pop hl
scr_addr de,57+15,16
call dec3
ld hl,(kused)
scr_addr de,57+15,15
call dec3
call showt
push iy
ld iy,#ff
scr_addr de,1,3
call first
.lpshowf
call checkhl
jr c,nofs
push hl
call showf2
inc ly
ld a,ly
cp 20
jr nz,norow
inc hy
ld ly,0
.norow
call nxfline
jr c,enddisp
.trynext
pop hl
inc hl
jr lpshowf
.enddisp
pop hl
jr anymore

.nofs
push de
ld c,0
call fprint
db -17," ",#ff
pop de
call nxfline
jr nc,nofs
.anymore
ld (maxcp),iy
pop iy
ret

.showf
push hl
call showf2
ld hl,17
add hl,de
ex de,hl
pop hl
ld a,l
add 20
ld l,a
ret

.cshow
call coffset
pop bc
push hl
push bc

.showf3		;HL points to file number
ld l,(hl)
ld lx,#ff
xor a
jr showf4

.showf2
ld lx,#00
ld l,(hl)
ld h,dalloch
ld a,(hl)
.showf4
push de
push af
call faddr
call pfile
pop af
and #40
ld a,32
jr z,usespc
ld a,"*"
.usespc
call fastch
pop de
ret

.showt
scr_addr de,57+15,18
ld hl,(ftagged)
call dec3
scr_addr de,57+15,19
ld hl,(ktagged)
jp dec3

; Get address of first file in HL
.first
ld a,(firstf)
ld l,a
ld h,sortedh
ret

.ramcode
ld c,7
push bc
ld h,b
call KL_INIT_BACK
pop bc
call KL_ROM_SELECT
jp begun

.adjust equ ramaddr - ramcode
.adjustc equ adjust + #c000

.rst8ad equ $ + adjust
rst #08,#c000  ;; Top two bits disable ROMs

.winrout5 equ $ + adjust
ld c,5
ld de,winbuff
.winrout equ $ + adjust
ld (rst8ad + 1),a
.winlp
push bc
push hl
ld c,b
ld b,0
call rst8ad
pop hl
call nwline
pop bc
jr nc,winlp
dec c
jr nz,winlp
ret

.cdisp equ $ + adjustc
ld b,c
.xorlp
ld a,(hl)
cpl
ld (hl),a
inc hl
djnz xorlp
ret

.ramldir equ $ + adjustc
ldir
ret

.ramexldir equ $ + adjustc
ex de,hl
ldir
ex de,hl
ret
.endcurs

.nwline
ld a,h
add 8
ld h,a
ret nc
ld bc,#c050
add hl,bc
scf
ret

.nxfline	;Carry set if at last pos
ld hl,#50
add hl,de
scr_addr bc,0,23
call cpbchl
jr nc,nline
scr_addr bc,18,-20,0  ; Adjust left by 18, up by 20
add hl,bc
scr_addr bc,48,3      ; Not sure why 48
call cpbchl
.nline
ex de,hl
ret

.pfile		;Displays filename of file at HL
push hl
ld l,(hl)
ld h,0
ld hx,#20
call dec3b
ld a,":"
call fastch
pop hl
inc hl
ld b,8
call pmask
ld a,"."
call fastch
ld b,3

.pmask
ld a,(hl)
inc hl
push bc
bit 7,a
jr z,b7i0
ld c,#ff
.b7i0
and #7f
call fastch
pop bc
djnz pmask
ret

.checkhl2
ld bc,(lastf2)
jr cpbchl

.checkhl	; Compare HL to last file address	
ld bc,(lastf)

.cpbchl
ld a,b
sub h
ret nz
ld a,c
sub l
ret

.showmenu
ld hl,keystate
cp (hl)
ret z
ld (hl),a
or a
jr nz,notmain
call setcff
db "MAIN",#ff
call showmen
; Attributes  Copy  Erase  Filespec  Move  Rename  Tag  Un-tag
db #a5,#fe,"F",#b4,"pec",-3," ",#fe,"Move",-3," ",#fe,"R",#bd,#a6,"  ",#ff
ret

.klist0
db "A":dw AttribSingle
db "C":dw CopySingle
db "E":dw EraseSingle
db "F":dw Filespec
db "M":dw MoveSingle
db "R":dw Rename
db "T":dw TagSingle
db "U":dw UntagSingle
db 0

.notmain
dec a
jr nz,notshft
call setcff
db "SHIFT",#ff
call showmen
; Backup  Configure  Format  Log disc  Sort  Un-log disc  Verify
db #fe,"B",#d7,-3," ",#fe,"C",#cf,"  ",#fe,"F",#ae,-3," ",#fe,"Log "
db #b6,"  ",#fe,"Sort",-3," ",#fe,"Un-log ",#b6,"  ",#fe,"V",#af,#ff
ret

.klist1
db "B":dw Backup
db "C":dw Configure
db "F":dw Format
db "L":dw LogDisc
db "S":dw SortFiles
db "U":dw UnLogDisc
db "V":dw Verify
db 0

.notshft
call setcff
db "CONTROL",#ff
call showmen
; Attributes  Copy  Erase  Move  Tag  Un-tag
db #a5,#fe,"Move ",#a6,-19," ",#ff
ret

.klist2
db "A"-64:dw AttribMulti
db "C"-64:dw CopyMulti
db "E"-64:dw EraseMulti
db "M"-64:dw MoveMulti
db "T"-64:dw TagMulti
db "U"-64:dw UntagMulti
db 0

.showmen
call fprint
db #c0,#ff	; Space, Colon, Space 

.fprint
ex (sp),hl
call fprint2
ex (sp),hl
ret

.getuwkey		; Get Uppercase Key, Carry set if escape pressed
call KM_WAIT_KEY
jr testesc

.getukey
call TXT_PLACE_CURSOR
call KM_WAIT_KEY
push af
call TXT_PLACE_CURSOR
pop af
.testesc
call uppercase
cp #fb			; Uses #FB rather than #FC so Z is not set
ccf
ret

.getdrive
call getukey
jp c,cont
cp "A"
jr c,getdrive
cp "C"
jr nc,getdrive
call TXT_OUTPUT
sub "A"
ret

.coffset
ld hl,(curpos)
ld a,h
add a
add a
add h		;*5
add a
add a		;*20
add l
ld l,a
ld a,(firstf)
add l
ld l,a
ld h,sortedh	;HL=sorted+cursor offset
ret

.findsame	;Finds entry A from sortedx
ld bc,#100
ld hl,sortedx
cpir
dec hl
ret		;Returns with Z set if found

.attmes
call mestop
db "Set ",#ff
ret

.AttribSingle
call clastf
call attmes
call cshow
ld e,#95
call getatt
ld (attset),hl
pop hl
ret c
call forone
jp writedir

.AttribMulti
call ctagged
call attmes
call alltag
call getatt
ret c
ld (attset),hl
call fortagged
jp writedir

.attf
push hl
ld l,e
call faddr
ld bc,(attset)
ld a,l
add c
ld l,a
ld a,(hl)
and #7f
or b
ld (hl),a
pop hl
ret

.copyf			; Read a single file
ld (rfptr),hl
push hl
ld l,e
call faddr
ld (rfname),hl
push hl
call savelog
ld a,(doit)
or a
jr nz,notbeg
call showrf
ld hl,16
ld (blkoff),hl
xor a
.notbeg
ld hl,(crsect)
ld (hl),a		; Byte 0 = Zero for first block
ld a,h
ld (doit),a
inc h:inc h
ld (recaddr),hl
xor a
ld (sectoff),a
ld bc,5
call testfree
pop ix
ld a,(exmsk)
and (ix+12)		; Number of 16K blocks
ld d,a
xor a
srl d
rra
add (ix+15)		; Number of 128 byte blocks
ld e,a
jr nc,noih
inc d			; Actual number of 128 byte blocks
.noih
or d			; It appears AMSDOS or some other programs create 0 size entries
jp z,noblks
push de
ld hl,(crsect)		; Bytes 3,4 = crsect
ld l,4
ld (hl),d
dec hl
ld (hl),e
dec hl
ld de,(rfptr)		; Bytes 1,2 = rfptr
ld (hl),d
dec hl
ld (hl),e
dec hl
ld bc,5
call wbuff
pop bc
.rdloop
push bc
ld bc,#80
push bc
call testfree
ld hl,(recaddr)
ld a,(crsect+1)
add 2
sub h
jr nz,notfbu
or l
jr nz,notfbu
ld a,(sectoff)
or a
jr nz,notfstsc
ld hl,(rfname)		; First sector in block
ld bc,(blkoff)
add hl,bc
ld e,(hl)
inc hl
inc c
ld d,b
ld a,(dsm+1)
or a
jr z,gotdev
ld d,(hl)
inc c
.gotdev
ld a,c
and #df
or #10
ld (blkoff),a
ex de,hl		; Now HL=block number
ld a,(fspec)
call getblk
ld (trksec),hl
.notfstsc
call read_src_sect
.notfbu
pop bc
call wbuffbc
add hl,bc
ld (recaddr),hl
pop bc
dec bc
ld a,b
or c
jp nz,rdloop
.noblks
pop hl
ret

.read_src_sect
ld hl,(trksec)		; H is sector, L is track
push hl
ld c,h
ld d,l
ld hl,(crsect)
ld (recaddr),hl
ld a,(fspec)
ld e,a
call read_sector	; Read one sector (Drive E, Track D, Sector C)
pop bc
ld hl,sectoff
call nextsec
ld (trksec),bc
jp break

.write_dst_sect
push hl
ld a,(formdrv)
ld e,a
ld d,l
ld c,h
ld hl,vbuff
ld (wrecad),hl
call write_sector
pop bc
ld hl,wsectof
call nextsec
ld (wtrksec),bc
jp break

.wbuffbc
push bc
ld hl,(recaddr)
push hl
call wbuff
pop hl
pop bc
ret

.nextsec
inc b

call isms8		; If MS-800, different last sector for first track
ld a,(sect3)
jr nz,ss3
ld a,#ca
inc c
dec c
jr z,ss3
ld a,#7b

.ss3
cp b
jr nz,samet
ld a,(sect2)
ld b,a
inc c
.samet
ld a,(blmsk)
rra:rra:and 15
inc (hl)
and (hl)
ld (hl),a
ret

.tsame
ld a,(formdrv)
ld e,a
ld a,(fspec)
cp e
ret

.checkdest			; Returns Z if escape pressed
call tsame

ld hl,dlogged
cp (hl)
jr c,allog
dec (hl)
call inmesd
scf				; Should always return C first time only
ret

.allog
xor e				; Need to clear carry
ret nz

.inmesd				; Returns Z if escape pressed
push de
call mestop
db #db,"destination ",#b6,#ff	; Insert destination disc
dec de
ld a,(formdrv)
call indrive2			; Z set if escape pressed
jp z,abort
pop de
ret

.inmess				; Return Z if escape pressed
call tsame
ret nz
call mestop
db #db,"source ",#b6,#ff	; source disc

.insrc
dec de
ld a,(fspec)
.indrive2
call indrive

.nomen2				; Clear the menu bar and leave it empty
push af
call nomen
db #ff
pop af
ret

.testfree			; Test if BC bytes are free in the buffer
call checkfree
ret nc
call emptycb			; If not, empty the copy buffer

.showrf
call setcff
db #d9,#d8,#ff
ld hl,(rfptr)
jr showrwf

.showwf
call setcff
db #da,#d8,#ff
ld hl,(wfptr)
.showrwf
call showf3
ld hl,#1b01
jp TXT_SET_CURSOR

.exitcp
ld a,1
ld (wclose),a

.emptycb
call checkdest
jr nc,dorelog

ld a,e
call loga
call dirinfe
ld hl,(ddir)
call rsects
ld (endddir),hl
call savelog_dest
jr nodmes

.dorelog
call relogd

.nodmes
ld hl,(wblks)
ld a,h
or l
jr z,getnewe
call showwf
jp notnewe

.getnewe		;New file entry
call checkused
jp z,exitwr
ld bc,5
ld hl,ffile
call rbuff
call showwf
ld a,(ffile)
or a
jr z,makenew
ld a,(needent)
or a
jr z,setnewe
jp notnewe

.makenew
ld hl,16
ld (wblkof),hl
ld l,h
ld (wsectof),hl
ld (wextent),hl
ld hl,(wfptr)
ld l,(hl)
call faddr
ld (wfloc),hl
ex de,hl	;DE points to filename
ld hl,(ddir)
call find2
jr nz,setnewe
push bc
push de
push hl
call exists
call cprint
db #dc,"Overwrite",#ff	; - Overwrite (Y/N) ;
call getyn
jp c,abort
call nomen2
pop hl
pop de
pop bc
sub "Y"
ld (writeyn),a
jr nz,isnewe
.erasede
ld (hl),#e5
call contfind
jr z,erasede

call showwf

.setnewe
call getfentry
ld a,h
or l
jp z,dirfull
ld (wrtany),a
ld (needent),a
ld (writeent),hl
ex de,hl
ld hl,(wfloc)
ld bc,12
ldir
ld a,(wextent)
ld (de),a
inc e
ld bc,3+16
call clrdebc

.isnewe
ld hl,vbuff
ld (wrecad),hl

.notnewe
ld hl,(wblks)
ld a,h
or l
jp z,getnewe

call checkused
jp z,exitwr

ld hl,(wrecad)
ld bc,#80
call rbuff
ex de,hl
ld hl,(wblks)
dec hl
ld (wblks),hl
ld a,(writeyn)
or a
jr nz,notnewe

ld (wrecad),de
ld a,h
or l
ld hl,vbuff+#200
jr z,writesect

call cphlde
jr nz,noteos

.writesect
ld hl,(wtrksec)
ld a,(wsectof)
or a
jr nz,notnewb

call getfreeb
jp c,discfull
ld hl,(writeent)
ld bc,(wblkof)
add hl,bc

ld (hl),e
inc hl
inc c
ld a,(dsm+1)
or a
jr z,noputd
ld (hl),d
inc hl
inc c
.noputd
ld a,c
and #df
or #10
ld (wblkof),a
push de
call usedblk
pop hl
ld a,(formdrv)
call getblk

.notnewb
call write_dst_sect

.noteos
ld ix,(writeent)
inc (ix+15)
jp p,notnewe
ld hl,wextent
inc (hl)
ld a,(exmsk)
and (hl)
jr nz,incext
ld hl,(wblks)
ld a,h
or l
jp nz,setnewe
ld (needent),a
jp getnewe
.incext
ld (ix+15),0
inc (ix+12)
jp notnewe

.dirfull
call didrv
db #be,#ff		; irectory

.discfull
call didrv
db #b5,#ff		; isc

.didrv			; Disc or Directory full
ld de,(wfloc)
ld hl,(ddir)
call find2
jr nz,noeyet
.erahalf
ld (hl),#e5
call contfind
jr z,erahalf
.noeyet
call mestop
db "D",#ad,#ff		; Drive
ld a,(formdrv)
add "A"
call fastch
call fprint
db ": d",#ff
pop hl
call fprint2
call fprint
db "full",#ff
push de

ld a,1
ld (wclose),a
ld (werror),a

.exitwr
ld hl,(endddir)
call setbuff2
ld a,(wclose)
or a
jp z,relogs

ld a,(wrtany)
or a
jr z,nowrtaa

call relogd
ld hl,(ddir)
call wsects

.nowrtaa
ld a,(werror)
or a
jr z,nowerr

pop de
ld c,#ff
call fprint
db #dc,"P",#ba,#ff		; - Press any key
call KM_WAIT_KEY

.nowerr
ld hl,cont
push hl

ld hl,(crsect)
call setbuff2

.relogs
call inmess			; Insert source disc
jp z,abort
call relog
jp dirinf

.getfreeb		;No carry if free block
ld hl,formbuff
ld b,#60
ld a,#ff
.findfre
cp (hl)
jr nz,fndfre
inc hl
djnz findfre
.fndfre
ld a,(hl)
ld h,0
add hl,hl
add hl,hl
add hl,hl
dec l
.getfrel
inc l
rla
jr c,getfrel
ex de,hl

.cpdsmde
ld hl,(dsm)
jp cphlde

.getfentry
ld de,formbuff+1	;Create block allocation map, and find free entry
ld bc,#5f
call clrdebc
ld a,(formdrv)
ld e,a
ld a,#9
call getdrvdpbv
ld (formbuff),a		;Allocate directory blocks

ld ix,(endddir)		;For each directory entry
ld hl,0
ld a,(dire)
inc a
ld b,a

.allclp
ld de,-32
add ix,de
ld a,(ix)
cp #e5
jr z,skipit
push bc
push ix
ex (sp),hl
ld bc,16
add hl,bc
.nextalb
ld e,(hl)
inc hl
ld a,(dsm+1)
or a
jr z,setdvl
ld a,(hl)
inc hl
.setdvl
ld d,a
call usedblk
bit 4,l
jr nz,nextalb
pop hl
pop bc
jr conallc
.skipit
push ix
pop hl
.conallc
djnz allclp
ret

.usedblk
push hl
call cpdsmde
pop hl
ret c
ld a,e
and 7
inc a
ld b,a
srl d:rr e
srl e:srl e
ld d,formbuff / 256
ld a,1
.rcalp
rrca
djnz rcalp
ex de,hl
or (hl)
ld (hl),a
ex de,hl
ret

.getcdrive
call gettodrive
call nomen2
ld bc,#2000
.initcb2
call initcb
xor a
ld (dlogged),a
ld (wclose),a
ld (werror),a
ld (wrtany),a
ld h,a
ld l,a
ld (wblks),hl
ld de,copyf
ret

.gettodrive
call fprint
db #b8,"d",#ad,": ",#ff		;  to drive;

.getcdrive2
call getdrive
ld (formdrv),a
ret

.CopySingle
call clastf
call copmess
call cshow
scr_addr e,22,24
call getcdrive
pop hl
call forone
jp exitcp

.CopyMulti
call ctagged
call copmess
call alltag
call getcdrive
call fortagged
jp exitcp

.mestop
call nomen2

.setcff		; Inverse print at 1,24
ld c,#ff
scr_addr de,1,24
jp fprint

.copmess
call nomen
db 31,35,1,#ff	; Locate to 35,1
call setcff
db "Copy ",#ff
ret

.erames
call nomen
db 31,24,1,#ff
call setcff
db "E",#bf," ",#ff		; Erase
ret

.alltag
call fprint
db "all t",#ab,"f",#b4,#ff	; all tagged files
ret

.EraseSingle
call clastf
call erames
call cshow
call getyn
pop hl
ret nz
call forone
call writedir
jp newfs

.EraseMulti
call ctagged
call erames
call alltag
call getyn
ret nz
call fortagged
.newfs2
call writedir
jp dosort

.MoveSingle
call clastf
call movmes
call cshow
scr_addr e,22,24
call getmuser
pop hl
ret z
call forone
jr newfs2

.MoveMulti
call ctagged
call movmes
call alltag
call getmuser
ret z
call fortagged
jr newfs2

.movmes
call mestop
db "Move ",#ff
ret

.getmuser
call fprint
db #b8,"u",#a7,#ff		;  to user number
ld hl,#2901
ld ix,tuser
.entul
call entuser2
cp #f3
jr z,entul
cp #fc
ret z
ld a,b
or a
ret z
ld hl,tuser
call convuser
ld (destuser),a
ld de,movf
or d
ret

.movf
push hl
ld l,e
call faddr
ld a,(destuser)
ld (hl),a
.popret
pop hl
ret

.getatt
call fprint
;  to; Read only  read/Write  Directory  System
db #b8,": ",#fe,"R",#b1,"  read/",#fe,"Write  "
db #fe,"D",#be," ",#fe,"System",#ff
.getatl
call getuwkey
ret c
ld de,attf
ld hl,#8009
cp "R"
ret z
ld h,#0
cp "W"
ret z
inc l
cp "D"
ret z
ld h,#80
cp "S"
jr nz,getatl
ret

.getyn
call cprint
db #dc,#d2,#ff		;  - (Y/N) ;
call getukey		; TODO; ESC = C, NZ
ret c
ld de,eraf
cp "Y"
jr z,bb5a
ld a,"N"
or a			; Ensure no Carry
.bb5a
jp TXT_OUTPUT

.Filespec
call nomen
db "U",#a7,#ff				; User number
ld hl,unumb
call cprint2
call cprint
db 31,25,1,"F",#b4,"pec",#c0,#ff	; Filespec ;
.entfile
ld hl,#2401
call enter
cp #f2
jr nz,notf2
ld hl,#1001
call entuser
cp #f3
ld a,b					; Number of characters entered for User
ld (userl),a
jr z,entfile
.notf2
ld a,(userl)
or a
ld a,1
jr z,setall
dec a
.setall
ld (fspec + 1),a
ld hl,unumb
call convuser
ld (fspec + 2),a
call convmask
ld a,(fspec)
inc a
ret z
jp newfs

.convuser
ld bc,#300
.numlp
ld a,(hl)
cp " "
jr z,finc
ld a,c
add a
add a
add c
add a
add (hl)
sub 48
ld c,a
inc hl
djnz numlp
.finc
ld a,c
ret

.Rename
call clastf
call mestop
db "R",#bd,#ff		; Rename
call cshow
ld e,#98
call fprint
db #b8,":",#ff		;  to ;
ld hl,tempf
ld b,12
.cltfl
ld (hl)," "
inc l
djnz cltfl
ld (hl),#ff
ld hl,#1f01
ld ix,tempf
call enter3
cp #fc
jr z,popret2
ld a,b
or a
.popret2
jp z,popret
ld hl,tempf2+1
ld de,tempf
call convmask2
pop hl
push hl
ld l,(hl)
call faddr
ld a,(hl)
ld (tempf2),a
call find1
pop hl
jr nz,dorenit
ld hl,tempf2
call exists

.anykey
call cprint
db #dc,"P",#ba,#ff	; - Press any key
jp KM_WAIT_KEY

.dorenit
ld de,renf
call forone
jp newfs2

.exists
push hl
call mestop
db "File ",#ff
pop hl
ld lx,#ff
call pfile
call cprint
db 31,24,1,"exists",#ff
ret

.find1
ld de,tempf2
ld hl,#100
.find2
ld a,(dire)
inc a
ld b,a
.loopff
push bc
ld b,11
call compare2
jr nz,notfile
pop bc
ret
.contfind
push bc
.notfile
ld bc,32
add hl,bc
pop bc
djnz loopff
ret

.renf
push hl
ld l,e
call faddr
inc hl
ld b,11
ld de,tempf2+1
ex de,hl
.renlp
ld a,(de)
and #80
or (hl)
ld (de),a
inc l
inc de
djnz renlp
pop hl
ret

.UntagSingle
ld de,untagf
jr TagSingle+3

.TagSingle
ld de,tagf
call clastf
call coffset
push hl
call forone
pop hl
ld de,(curadr)
call showf
call showt
pop hl
call cursor3+3
jp godown

.tagf
bit 6,a
ret nz
push hl
or #40
ld (de),a
call getfze
add hl,bc
bit 0,a
jr z,setkt
inc de
.setkt
ld (ftagged),de
ld (ktagged),hl
pop hl
ret

.eraf
ld a,(doit)
or a
ret nz
push hl
ld l,e
call faddr
push hl
pop ix
bit 7,(ix+9)		;Is file read-only?
jr z,notro
ld a,(de)
and 1
jr z,notro
pop hl
push hl
push de
push ix
push hl
call nomen
db 31,20,1,"is r",#b1,". E",#bf,#ff	; is read only. Erase
pop hl
scr_addr de,1,24
call showf3
call getyn
pop hl
pop de
jr z,notro
ld a,1
ld (doit),a
pop hl
ret

.notro
ld (hl),#e5
pop hl
ld a,(de)

.untagf
bit 6,a
ret z
push hl
and #bf
ld (de),a
call getfze
or a
sbc hl,bc
bit 0,a
jr z,setkt
dec de
jr setkt

.getfze
push af
ld l,e
call faddr
push hl
pop ix
call getfsz
ld c,a
ld b,0
ld de,(ftagged)
ld hl,(ktagged)
pop af
ret

.forone
ld (fordo+1),de
.forsin
ld a,(hl)
call findsame
ld e,(hl)		;File offset
ld d,dalloch
xor a
ld (doit),a
ld a,(de)
call fordo		;E=entry #, D=dalloch
.foronel
inc hl
call checkhl2
ret c
ld e,(hl)
ld d,dalloch
ld a,(de)
bit 0,a
ret nz
call fordo
jr foronel

.fortagged
ld (fordo+1),de
ld hl,sorted
.foratlp
call checkhl
ret c
push hl
ld e,(hl)
ld d,dalloch
ld a,(de)
and #41
cp #41		;Tagged and first entry
call z,forsin
pop hl
inc hl
jr foratlp

.Backup		; TODO - Support for MS800?
ld a,(fspec)
inc a
ret z
call nomen
db 31,20,1,#ff	; Locate 20,1
call setcff
db "B",#d7,#ff
call gettodrive
inc c:ld b,c
ld hl,(sect1 - 1)
ld l,c
ld (trksec),hl
ld (wtrksec),hl
call initcb2
call savelog
call setcurrform	; For MS-800 this is one bigger
ld a,d
ld (maxtrk),a
call set0form
call lockfmtdpb

.bkread
call bkend
jp c,relog
.showrm
call setcff
db #d9,#bb,#ff
.showrt
ld a,(trksec)
call showbktrk
ld bc,#200
push bc
call bkfree
call read_src_sect	; Returns with B = next sector, C = next track
pop bc
call wbuffbc
call bkend
jr nc,showrt
jr bkwrite

.bkend
ld a,(trksec)
ld d,a
ld a,(maxtrk)
cp d
ret

.bkfree
call checkfree
ret nc
.bkwrite
call checkdest
push de
call setcff
db #da,#bb,#ff
.bkwrlp
call checkused
jr nz,gotsects
ld hl,(ddir)
call setbuff2
call inmess
jp z,abort
ld sp,#bffe		; Will always be this value at bkread
jr bkread

.gotsects
ld a,(wtrksec)
call showbktrk
pop de			; E is Dest Drive
push de
ld hl,(wtrksec)
push hl
ld a,(formbuff + 2)	; First sector in format
cp h
jr nz,noform
ld d,l
call fmttrk
call setcurrform
call lockfmtdpb
.noform
ld hl,vbuff
ld bc,#200
call rbuff
pop hl
call write_dst_sect
jr bkwrlp

.Configure
call mestop
; Configure; Drive setup  Format setup
db "C",#cf,": ",#fe,"D",#ad,#ce,"  ",#fe,"F",#ae," ",#ce,#ff
.notsetf
call getuwkey
ret c
cp "D"
jp z,confdrvs
cp "F"
jr nz,notsetf
call nomen2
scr_addr de,4,9
ld bc,#1aff
call tline
call hline2
call mline
call hmline4
ld a,2
call hmlinea
call hline2
call bline
scr_addr de,5,20
call fprint
db "Ok",#ff
ld a,3
ld (currf),a
.dshfl
call showfen
.dcurslp2
call fdcurs
call getuwkey
push af
call fdcurs
pop af
ld b,3
call updown
jr z,dcurslp2
ld hl,RAM_DPB
ld c,DPB_ELECTRO
or a
jr z,setelf
ld c,DPB_ULTRAFORM
dec a
jr nz,setelf
ld c,DPB_IBM
bit 2,(hl)	; If the bit is already set, toggle it and VORTEX_PCW
jr z,setelf
ld c,DPB_IBM + DPB_VORTEX_PCW
.setelf
ld a,(hl)
xor c
ld (hl),a
dec l:dec l
ld (hl),a
jr dshfl

.fdcurs
ld bc,#1a01
ld a,(currf)
or a
jr z,isy0
cp 3
jr nz,noty3
ld a,10
jr isy0
.noty3
add a
ld c,4
cp c
jr nz,isy0
ld c,2
ld a,7
.isy0
push bc
call times80
pop bc
scr_addr de,5,10
add hl,de
jp cursdisp

.showfen
ld c,#ff
scr_addr de,5,10
call fprint
db "ELECTRO ",#d6,#ff	; ELECTRO Formats
ld a,(RAM_DPB)
ld h,a
and DPB_ELECTRO
call endis
scr_addr de,5,17
call fprint
db #c2,"10",-5," ",#ff		; ROMDOS D10
bit 3,h
call iendis
scr_addr e,5,18			; Same MSB
call fprint
db #d0,-6," ",#ff		; ULTRAFORM
bit 3,h
call endis
scr_addr de,5,12
call fprint
db #c2,"1",-6," ",#ff		; ROMDOS D1
ld a,h				
and DPB_VORTEX_PCW + DPB_IBM
ld h,a
call iendis			; Check D1 (NZ) Disabled (Z) Enabled
scr_addr de,5,13		
call fprint
db #c5,#d6,-4," ",#ff		; IBM Formats
ld a,h
cp DPB_IBM			; Check IBM Formats (NZ) Disabled
call iendis
scr_addr e,5,14			; Same MSB
call fprint
db #d4,-8," ",#ff		; VORTEX
ld a,h
cp DPB_VORTEX_PCW
call iendis
scr_addr e,5,15			; Same MSB
call fprint
db #d5,#d6,-4," ",#ff
ld a,h
cp DPB_VORTEX_PCW + DPB_IBM

.iendis
jr z,enabd
xor a
.endis
jr z,diabd
.enabd
call fprint			;; TODO: *** Can optimise here ***
db #c0,"Enabled ",#ff		; ; Enabled
ret
.diabd
call fprint
db #c0,"Disabled",#ff		; ; Disabled
ret

.confdrvs
call nomen2
scr_addr de,4,9
ld bc,#15ff
call tline
call hmline4
call hmline4
call hline2
call bline
scr_addr de,5,20
call fprint
db "Ok",#ff
ld a,6
ld (currf),a
.sdrvslp
call shwdrvs
.dcurslp
call ddcurs
call getuwkey
push af
call ddcurs
pop af
ld b,6
call updown
jr z,dcurslp

inc a
ld b,a
sub 4
ld e,0
jr c,isddv0
inc a
ld b,a
inc e
.isddv0
call getddb_e
djnz ns4080
xor 2
bit 3,a
jr z,setvddb
and #0d
jr setvddb
.ns4080
djnz nssides
ld h,a
and #05
ld a,h
jr nz,isdsdd
xor #04
jr setvddb
.isdsdd
xor #01		;Now single sided
and #0b
jr setvddb
.nssides
xor 8
bit 1,a
jr z,setvddb
and #07
.setvddb
and #f
ld c,a
add a:add a:add a:add a
ld b,a
ld hl,RAM_DDB
ld a,(hl)
dec e
jr z,isdrv1
and #f
or b
.setddbb
ld (hl),a
dec l:dec l
ld (hl),a
jr sdrvslp
.isdrv1
and #f0
or c
jr setddbb

.updown
jr c,endsud
ld hl,currf
cp #f0
jr nz,notdscu
ld a,(hl)
or a
ret z
dec (hl)
xor a
ret
.notdscu
cp #f1
jr nz,notdscd
ld a,(hl)
cp b
ret z
inc (hl)
.dcursss
xor a
ret
.notdscd
cp 13
jr nz,dcursss
ld a,(hl)
cp b
ret nz
.endsud
pop hl
jp clmain

.ddcurs
ld a,(currf)
cp 3:jr c,lessy3
inc a:inc a
.lessy3
cp 8:jr nz,lessy6
inc a
.lessy6
call times80
scr_addr bc,5,11
add hl,bc
ld bc,#1501
jp cursdisp

.shwdrvs
scr_addr de,5,10
xor a
call shwdrve
scr_addr de,5,15
ld a,1
.shwdrve
ld c,0
push de
push af
call getddb_a
ld h,a
call fprint
db -6," D",#ad,#ff	;  Drive
pop af
add 65
call fastch
call fprint
db ":",-7," ",#ff
pop de
call dnlne
push de
ld c,#ff
bit 1,h
ld a,"4"
jr z,trk40t
ld a,"8"
.trk40t
call fastch
call fprint
db "0 tracks per side",#ff
pop de
call dnlne
push de
bit 0,h
call sdoub
call fprint
db "le sided ",#ff
bit 0,h
jr nz,isdoub
call fprint
db "(Side ",#ff
ld a,"0"
bit 2,h
jr z,issd0
inc a
.issd0
call fastch
ld a,")"
call fastch
jr isndoub
.isdoub
call fprint
db -8," ",#ff
.isndoub
pop de
call dnlne
bit 3,h
call sdoub
call fprint
db "le-stepping",#ff
ret

.sdoub
jr z,sings
call fprint
db "Doub",#ff
ret
.sings
call fprint
db "Sing",#ff
ret

.Format
ld hl,RAM_DPB
set 0,(hl)
call nomen
db "D",#ad,#cb,"f",#ae,#c0,#ff		; Drive to format ;
call getcdrive2
push af
call nomen
db "Select f",#ae," for D",#ad,#ff	; Select format for Drive
pop af
push af
add 65
call TXT_OUTPUT
ld a,":"
call TXT_OUTPUT
pop af
ld e,a
call sdrv
ld e,a
ld ix,formbuff
ld bc,numforms * #100		;Number of formats
ld hl,forms+3
.checkf
ld a,(hl)
inc hl
inc hl
and e
jr z,noput
ld (ix+0),l
ld (ix+1),h
inc c
inc ix
inc ix
.noput
call skip0
inc hl
inc hl
inc hl
djnz checkf
ld a,c
ld (numfr),a
cp 16
jr c,less16
ld a,16
.less16
ld (scrls),a
push af
ld hl,#505
ld de,#1414
call TXT_WIN_ENABLE
ld c,#ff
scr_addr de,4,21
ld b,#90
call bline
pop af
call mhline
inc hl
ld (basea),hl
call tline
xor a
ld (basef),a
ld (currf),a
ld c,a
ld a,(scrls)
ld b,a
ld de,(basea)
.shflp
call showfr
djnz shflp
.waitfc
call fcursor
call getuwkey
jp c,clmain
push af
call fcursor
pop af
ld hl,currf
cp #f0
jr nz,notufc
ld a,(hl)
or a
jr z,waitfc
ld a,(basef)
cp (hl)
jr nz,noscruf
dec a
ld (basef),a
ld c,a
dec (hl)
call cprint
db 31,1,1,11,10,#ff
scr_addr de,5,5
jr showfrc
.noscruf
dec (hl)
jr waitfc
.notufc
cp #f1
jr nz,notdfc
ld a,(numfr)
ld b,a
ld a,(hl)
inc a
cp b
jr z,waitfc
ld (hl),a
ld a,(basef)
ld b,a
ld a,(hl)
sub b
cp 16
jr nz,waitfc
ld a,b
inc a
ld (basef),a
call cprint
db 31,1,17,10,#ff
scr_addr de,5,20
ld a,(currf)
ld c,a
.showfrc
call showfr
jr waitfc
.notdfc
cp 13
jr nz,waitfc
call clmain
call nomen
db "V",#af," while f",#ae,"ting",#ff	; Verify while formatting
call getyn
jp c,clmain
jr z,isyes
xor a
.isyes
ld (verform),a
call savelog
ld a,(currf)
ld c,a
call getffm
.reform
push hl
call mestop
db #db,#b7,"f",#ae,#b8,#ff		; disc to format to
pop hl
push hl
call fprint2
call fprint
db " f",#ae,#ff			; format
ld a,(formdrv)
call indrive
jp z,abort
ld hl,vbuff
ld de,vbuff+1
ld bc,#1ff
ld (hl),#e5
ldir
call nomen
db "F",#ae,"t",#bb,-4," ",#ff	; Formatting track (has 4 spaces to place cursor)
pop hl
push hl
call setform			; Set selected format (including RAM_DDB)
call setfmtdpb
dec hl
ld (hl),#ff
.formloop
push bc
push de
ld a,d
scr_addr de,20,24
call dec3a
call break
pop de
call fmttrk
pop bc
push bc
ld a,(verform)
or a
jr z,okv
ld hl,#1801
call TXT_SET_CURSOR
ld hl,vbuff
ld a,(formbuff+2)
ld c,a
.vloop2
call vsect
jr nz,nokv
djnz vloop2
call cprint
db #c1,#ff		; - Ok
jr okv
.nokv
call cprint
db 7,#dc,"E",#b9,#ff	; - Error
.okv
pop bc
ld a,d
dec d
or a
jr nz,formloop
call nomen
db "F",#ae,#d3,#ff	; Format another
call getyn
pop hl
jp z,reform
jp clrelog

.vsect			;Verifies sector C
push bc
push hl
call vsec
pop hl
pop bc
inc c
ld a,(FDC_BUFF_ST2)
and #3f
cp #08
ret

.vsec
call motor_on
ld a,#51
ld b,#11
jp read_sector + 7

.set0form
ld hl,dataf
call isms8
jr z,setform

.setcurrform
ld hl,(formdesc)

.setform	;Set format buffer to format at HL
		;Returns E=gap #3, B=# of sectors, D=last track
		;(obaff) = old DDB, (#baff)=setting for format
		;format setup at formbuff
dec hl
ld b,(hl)	;Number of sectors per track
dec hl
ld c,(hl)	;Format specifier
dec hl
dec hl
dec hl
push bc
res 7,b
ld a,b		;B=8, 9 or 10
ld (fmtspt),a
add (hl)
ld c,a		;Last sector + 1
ld de,#552	;9 sectors per track, interleave, gap #3
bit 0,b
jr nz,use9
ld e,#10	;10 sectors per track, gap #3
bit 1,b
jr nz,use9
ld de,#150	;8 sectors per track
.use9
ld a,(hl)
ld hl,formbuff
.use9l
inc hl
inc hl
ld (hl),a
inc hl
ld (hl),2
inc hl
add d		;Add interleave
cp c
jr c,noaddi
sub d
sub d
inc a
.noaddi
djnz use9l
pop bc
ld a,#ff
.checddb
inc a
srl c
jr nc,checddb
ld c,a
add a:add a:add a:add a
or c
ld c,a
ld hl,RAM_DDB
ld a,(hl)
; ld (obaff),a		;TODO - Is this ever used? Verify, Format, Backup
and #cc
or c
ld (hl),a		;Bit 0 = 1 for double sided
ld d,40
and 3
jr z,chkxtra
ld d,159		;No formats with 161 tracks
cp 3
ret z
ld d,80
.chkxtra
bit 7,b
res 7,b
ret nz
dec d
ret

.lockfmtdpb		; Need to lock for formatting destination drive (after setcurrform sets ddb)
ld hl,RAM_DPB
set 0,(hl)		

.setfmtdpb		; Entry E = Gap3, B = Sectors per track, Exit E = Drive
ld a,(formdrv)
ld c,e
ld e,a
ld a,#12
call getdrvdpb
ld (hl),c		; Gap length #3 (DPB #12)
dec hl
dec hl
ld (hl),b		; Number of sectors per track (DPB #10)
ret

.fmttrk			; Format track D on Drive E
ld a,(fmtspt)
ld b,a
ld hl,formbuff
push hl
ld c,d
ld a,(RAM_DDB)
and 1
jr z,nomod
srl c
jr c,nomod
xor a
.nomod
ld (hl),c
inc hl
ld (hl),a
inc hl
inc hl
inc hl
djnz nomod
pop hl
jp format_track		;Format track

.indrive
push af
call fprint
db " in d",#ad,#ff	;  in drive
pop af
add 65
call fastch
call fprint
db ": then p",#ba,#ff	; ; then press any key
call KM_WAIT_KEY
xor #fc			; Don't use cp because it may set carry
ret

.clmain		; Clear main window
call mainw
db 12,24,#ff	; Clear text window and exchange Pen & Paper inks
ret

.fcursor
ld a,(basef)
ld b,a
ld a,(currf)
sub b
call times80
ld bc,(basea)
add hl,bc
ld bc,#1001
jp cursdisp

.showfr
push bc
push de
call getffm
ld c,#ff
inc de
call fprint2
pop de
pop bc
inc c

.dnlne
push hl
ld hl,#50
add hl,de
ex de,hl
pop hl
ret

.getffm
ld hl,formbuff
ld b,0
add hl,bc
add hl,bc
ld a,(hl)
inc hl
ld h,(hl)
ld l,a
ret

.LogDisc
call nomen
db "Log Which D",#ad,": ",#ff	; Log Which Drive;
call getdrive
call loga
jp nc,UnlogDisc
ld a,e
ld (fspec),a

.getdir
call dirinf
call rsects
call setbuff
call getsort

.getfdesc		;Display current format
ld a,(fspec)
ld e,a
.getfdesce
ld a,#2
call getdrvdpb
ld d,(hl)		;BSH, block shift
inc hl
inc hl
inc hl
ld b,(hl)		;DSM, number of blocks - 1
ld a,#d
call getdrvdpb
ld a,(hl)		;OFF, reserved tracks
inc hl
inc hl
ld c,(hl)		;first sector number
ld hl,forms
cp 1
jr nz,notms8
ld hl,ms800f
.notms8
push de
call sdrv
add a:add a:add a:add a:ld e,a
call findf
pop de
jr nc,issame
.noformf
ld hl,unknown
.issame
ld (formdesc),hl
ret

.savelog_dest
ld a,(formdrv)
ld hl,savedpb+#1d
jr savelog2

.savelog	; Save the Logged Drive DPB, format descriptor and RAM_DPB/DDB
ld hl,savedpb
ld a,(fspec)

.savelog2
ld e,a
push hl
xor a
call getdrvdpb
pop de
ld bc,#16
ldir
ld hl,formdesc
ld c,5
ldir
ld hl,RAM_DPB
ldi
ldi
ret

.relogd
ld a,(formdrv)
ld hl,savedpb+#1d
call relog2
jp dirinfe

.relog
ld a,(fspec)
ld hl,savedpb

.relog2
ld e,a
push de
xor a
push hl
call getdrvdpb
ex de,hl
pop hl
ld bc,#16
ldir
ld de,formdesc
ld c,5
ldir
ld de,RAM_DPB
ldi
ldi
pop de
jp getfdesce

.loga
ld e,a
ld d,0
call getform
ret nc
ld (sect1),a	; Sector from Track 0
inc d
inc d
call getform
ret nc		; Only sect1 corrupted
ld (sect2),a	; Sector from Track 1
inc hl
ld b,(hl)	; Sectors per track
call isms8a
jr nz,nms800
dec hl		;#f
dec hl		;#e
dec hl		;#d
ld (hl),1	; OFF - Reserved Tracks
.nms800
ld a,(sect2)
add b		; Sectors per track
ld (sect3),a
scf
ret

.isms8
ld a,(sect2)
.isms8a
cp #71
ret nz
ld a,(sect1)
cp #c1
ret

; Get Drive Mask for E -> 1 = SS40, 2 = DS40, 4 = SS80, 8 = DS80
.sdrv
call chkdrv_e
and 3
inc a
cp 3
ret c
add a
and #0c
ret

.findf			;Carry set if not found
ld a,(hl)		;Check sector number
or a
scf
ret z
inc hl
cp c
ld a,(hl)		;Check block shift
inc hl
push hl
jr nz,nosame
cp d
jr nz,nosame
ld a,(hl)
inc hl
cp b
jr nz,nosame
ld a,(hl)
inc hl
inc hl
and e
jr z,nosame
inc sp:inc sp
ret
.nosame
pop hl
inc hl:inc hl
call skip0
jr findf

.skip0
ld a,(hl)
inc hl
inc a
ret z
jr skip0

.dirinf			; Get Directory Information for source drive
ld a,(fspec)
ld e,a

.dirinfe		; Get Directory Information for drive E
push de
ld a,#d
call getdrvdpbv		; Reserved Tracks
ld (resert),a
ld a,#2
call getdrvdpb		; Block Shift (#03 = 1k, #04 = 2k, #08 = 4k)
ld c,(hl)		; BSH in C
inc hl
ld a,(hl)		; Block Mask (#07 = 1k, #0f = 2k, #1f = 4k)
ld (blmsk),a
inc hl
ld a,(hl)		; Extent Mask (
ld (exmsk),a
inc hl
ld e,(hl)	;LSB of DSM
inc hl
ld d,(hl)	;MSB of DSM
inc hl
ld (dsm),de
ld a,(hl)	;DRM
ld (dire),a
inc hl
inc hl
srl a:inc a	;32
and #e0
rra:rra:rra
ld (dirsc),a
ex de,hl	;HL=DSM-1
inc hl
ld a,(de)	;AL0
ld de,0
ld b,8
.allop
add a
sbc hl,de
djnz allop
ld a,c		;HL=number of blocks
sub 3
jr z,nobshft
.bshft
add hl,hl
dec a
jr nz,bshft
.nobshft
ld (totalk),hl
pop de
.getdir2
ld a,(resert)
ld d,a
ld a,(dirsc)
ld b,a
ld a,(sect2)
ld c,a
ld hl,#100
ret

.writedir
ld a,(fspec)
ld e,a
call getdir2
.wsects
ld ix,write_sector
jr rsects+4

.rsects		;B=number of sects, D=drive, E=track, HL=addr, C=sect
ld ix,read_sector
ld (rwcal+1),ix
.nxttrk
push bc
push hl
call rwcal
pop hl
pop bc
inc h
inc h
inc c
ld a,(sect3)
cp c
jr nz,notnxt
ld a,(sect2)
ld c,a
inc d
.notnxt
djnz nxttrk
ret

.getsort
ld hl,dalloc		;First clears the directory allocation map
ld a,(dire)
ld b,a
xor a
ld (hl),a
.gsl1
inc l
ld (hl),a
djnz gsl1
ld a,#80
.gsl2
inc l
jr z,lastde
ld (hl),a
jr gsl2

.lastde
ld hl,0
ld (ktagged),hl
ld (ftagged),hl

.dosort
push iy			;Then sorts the directory using a table at sortedx
ld iy,sortedx
ld hl,sorted
.clrsort
ld (hl),h
inc l
jr nz,clrsort
ld h,l
ld (lastf2),hl
.sort2
ld a,(dire)
inc a
ld b,a
ld c,0
.sort3
call checkent
jr nz,checkff
inc c
djnz sort3
pop iy
jp newfs

.checkff
ex de,hl
ld lx,c
.skipff
inc c
djnz other

ld a,lx
ld (iy+0),a
ld (lastf2),iy
inc iy
ld l,a
ld h,sortedh
xor a
ld (hl),a
jr sort2

.other
call checkent
jr z,skipff

push bc			;if entry at HL < entry at DE
call compare
pop bc
jr c,checkff		;if (DE) < (HL)
jr skipff

.compare
ld b,12
.compare2
push de
push hl
ex de,hl
ld a,(de)
cp (hl)
jr nz,lless
.compl1
inc l
inc e
ld a,(hl)
and #7f
ld c,a
ld a,(de)
and #7f
cp c
jr nz,lless
djnz compl1
.lless
pop hl
pop de
ret

.SortFiles
ld hl,issort
ld a,(hl)
cpl
ld (hl),a
jp dosort

.newfs
ld hl,0
ld (entries),hl		;Number of used directory entries
ld (files),hl
ld (kused),hl
ld de,dalloc		;Start of directory map
ld ix,#100		;First directory entry

.gmasklp
push ix
ld a,(de)		;bit 5=1 means not matching
cp #80			;1 means checked, first entry
jp z,noentry		;3 means checked, not first entry
			;bit 6 = 1 if tagged.
ld a,(ix+0)
cp #e5
jr nz,incentry
cp (ix+1)
jr z,nofile

ld hl,(files)
ld a,(exmsk)
jr chkmsk

.incentry
ld hl,(entries)
inc hl
ld (entries),hl

call getfsz

ld hl,(kused)
add l
ld l,a
ld a,h
adc 0
ld h,a
ld (kused),hl

ld hl,(files)
inc hl
ld a,c

.chkmsk
cpl
and (ix+12)
ld c,2
jr nz,noincc

ld (files),hl
dec c

.noincc
ld hl,fspec + 1
ld a,(hl)		;Check user number ?
inc hl
or a
jr z,ychk
ld a,(ix+0)
cp #e5
jr z,nomatch
jr chky
.ychk
ld a,(ix+0)
cp (hl)
jr nz,nomatch
.chky
ld b,11
inc ix
inc hl
ld a,(hl)
cp "?"
jr z,nocheck
ld a,(ix+0)
and #7f
cp (hl)
jr nz,nomatch
.nocheck
djnz chky+2
jr setix
.nofile
ld a,#82	;Un-used directory entry
jr setix2
.nomatch
set 5,c
.setix
ld a,(de)
and #40		;Preserve tagged flag
or c
.setix2
ld (de),a
.noentry
pop ix
ld bc,#20
add ix,bc
inc e
jp nz,gmasklp

.sort
xor a
ld (firstf),a
ld h,a:ld l,a
ld (lastf),hl
ld (curpos),hl
ld (maxcp),hl

ld hl,sortedx
ld de,sorted

ld a,(issort)
or a
jr z,sort4

ld hl,dalloc
.sort5
ld a,(hl)
and #bf
dec a
jr nz,nxfile4
ld a,l
ld (de),a
ld (lastf),de
inc de
.nxfile4
inc l
ret z
jr sort5

.sort4
call checkhl2
ret c
push hl
ld l,(hl)
ld h,dalloch
ld a,(hl)
and #bf
dec a
jr nz,nxfile3
ld a,l
ld (de),a
ld (lastf),de
inc de
.nxfile3
pop hl
inc hl
jr sort4

.checkent	;Check entry C
ld l,c
ld h,sortedh
ld a,(hl)
or a
ret z
call faddr
ld a,(hl)
cp #e5
ret nz
inc l
ld a,(hl)
dec l
cp #e5		;Unused directory entry?
ret nz
.nowsort
ld l,c
ld h,sortedh
xor a
ld (hl),a
ret

.getfsz		;Calculate size of entry at IX in 1K blocks
		;Value returned in A
ld a,(blmsk)
ld b,a
cpl
ld c,a
ld a,(ix+15)
add b
and c			;Number of #80 blocks
rra:rra:rra
and #1f
ld b,a			;Number of 1K blocks

ld a,(exmsk)
ld c,a
and (ix+12)		;Number of 16K blocks
add a:add a
add a:add a		;Number of 1K blocks
add b
ret

.faddr
ld h,0
add hl,hl	;*2
add hl,hl	;*4
add hl,hl	;*8
add hl,hl	;*16
add hl,hl	;*32
inc h
ret

.getform	;E=drive, D=track
		;Returns A=format, HL=DPB+#f
push de
call move_track
call scan_curr
pop de
ret nc
ld a,#f
call getdrvdpb
ld a,(hl)
scf
ret

.Verify
call nomen
db "D",#ad,#cb,"v",#af,#c0,#ff	; Drive to verify
call getdrive
ld (formdrv),a
push af
call mestop
db #db,#b7,"v",#af,#ff		; disc to verify
pop af
call indrive
ret z
call savelog
ld a,(formdrv)
call loga
jp nc,abort
call getfdesce
call mestop
db "D",#b5,"is ",#ff		; Disc is
ld hl,(formdesc)
ld c,#ff
call fprint2
call fprint
db " f",#ae,#dc,"V",#af,#bb,#ff	; format - Verifying track
ld (numadr),de
call mainw
db 12,31,2,2,"E",#b9,"s",#c0,26,11,#37,4,23,#ff	; Errors ; 
call set0form	; Returns Sectors in B
xor a
ld (verform),a
ld a,(formdrv)
ld e,a
ld a,d
ld d,0
.verloop
ld a,(formbuff+2)
ld c,a
push de
push de
push bc
ld a,d
ld de,(numadr)
call dec3a
pop bc
pop de
xor a
ld (verror),a

.vloop3
call break
push bc
push de
ld hl,vbuff
ld a,2
ld (AMSDOS_RETRIES),a
call read_Sector	;Read sector
ld a,16
ld (AMSDOS_RETRIES),a
jr c,sectok
ld a,1
ld (verror),a
ld (verform),a
.sectok
pop de
pop bc
jr nc,verrbad
inc c
djnz vloop3

.verrbad
ld de,(numadr)
inc de:inc de:inc de
ld a,(verror)
or a
ld c,#ff
jr z,okv2
call fprint
db #dc,"E",#b9,#ff	; - Error
pop hl
push hl
ld l,h
ld h,0
call decimal_hl
call cprint
db 7,"  ",#ff
jr nokv2
.okv2
call fprint
db #c1,#ff		; - Ok
.nokv2
call setcurrform
ld a,d
pop de
inc d
cp d
jr nc,verloop
ld a,(verform)
or a
jr z,noerrs
call nomen
db "V",#af," Failed",#ff	; Verify Failed
jr doany

.noerrs
call nomen
db "No e",#b9,"s found",#ff	; No errors found

.verrany
call tsame
jr nz,doany

call cursde
call fprint
db #dc,#db,"logged ",#b6,#ff
call insrc
jr escape

.doany
call anykey

.escape
ld sp,#bffe

.clrelog
call clmain
jp relog

.cursde
call TXT_GET_CURSOR
ld a,h
add #7f
ld e,a
ld d,#c7
ld c,#ff
ret

.notz
or #ff
ret

.break			; Only corrupts A unless escape is pressed twice
call KM_READ_CHAR
jr nc,notz
cp #fc
ret nz
call TXT_PLACE_CURSOR
call KM_WAIT_CHAR
push af
call TXT_REMOVE_CURSOR
pop af
cp #fc
ret nz

.abort
call nomen
db "Operation aborted",#ff
jr verrany

.TagMulti
call clastf
ld hl,tagf
.tagfa
ld (fordo+1),hl
ld hl,sorted
.foralp
call checkhl
ret c
push hl
call forsin
pop hl
inc hl
jr foralp

.UntagMulti
call ctagged
ld hl,untagf
jr tagfa

.backsp
call TXT_SET_CURSOR	;Locate
push ix
pop hl
call cprint2
dec hl
dec hl
.backspl
ld a,(hl)
cp " "
jr nz,notsp
dec hl
djnz backspl
.notsp
inc hl
ret

.entuser
ld ix,unumb
.entuser2
ld (xypos),hl
ld b,3
call backsp
.prlp2
call getkey2
ld de,prlp2
cp 13
ret z
cp #f3
ret z
push de
cp #80
ret nc
cp 16
jp z,clrfl
cp 127
jp z,delete
ld a,c
cp "0"
ret c
cp "9"+1
ret nc
ld a,b
cp 3
ret z
cp 2
jr nz,tch+1
ld a,(ix+0)
cp "2"
jr z,ok1
jr tch
.ok1		;if first digit is "2"
ld a,(ix+1)
cp "5"
jr z,ok2
jr tch
.ok2		;And second digit is "5"
ld a,c
cp "6"
.tch
ret nc
jp sch

.enter			;Call with H=x offset, L=y offset
			;Carry not set if escape pressed
ld ix,fspec2
.enter2
db #3e
.enter3
xor a
ld (alloww),a
ld (xypos),hl
ld b,12
call backsp
.prlp
call getkey2
ld de,illegal
.chnc
ld a,(de)
inc de
or a
jr z,osch
cp c
jr nz,chnc
jr prlp
.osch
ld de,prlp
ld a,c
cp 13
ret z
cp #f2
ret z
push de
cp #80
ret nc
ld a,(alloww)
or a
ld a,c
jr nz,awild
cp "*"
ret z
cp "?"
ret z
.awild
ld d,h
ld e,l
cp 16
jr z,clrfl
cp 127
jr z,delete
ld a,b
cp 12
ret z
ld a,c
cp "."
jr z,dot
ld a,b
or a
jr z,fstch
dec hl
ld a,(hl)
inc hl
cp "*"
ret z
call isdot
jr nc,isdot2
ld a,b
cp 8
ret nc
jr fstch
.isdot2
sub b
neg
cp 3
ret nc
.fstch
ld a,c
cp 33
ret c
jr sch

.clrfl
ld a,b
or a
ret z
ld c,32
dec hl
ld (hl),c
dec b
ld a,b
call shpc
jr clrfl

.delete
ld a,b
or a
ret z
ld c,32
dec hl
ld (hl),c
dec b
ld a,b
jr pch

.dot
call isdot
ret nc
.sch
ld (hl),c
inc hl
ld a,b
inc b
.pch
.shpc
call setxy+1
ld a,c
jp TXT_OUTPUT

.setxy
ld a,b
push hl
ld hl,(xypos)
add h
ld h,a
call TXT_SET_CURSOR
pop hl
ret

.convmask
ld hl,fspec + 3
ld de,fspec2

.convmask2	;DE=source, HL=dest
ld bc,#80c
call bit
ld b,3
ld a,(de)
inc de
cp "."
jr nz,fillsp+1
.bit
ld a,c
or a
ret z
ld a,(de)
inc de
dec c
cp "*"
jr z,fillq
cp "."
jr z,fillsp
call uppercase
ld (hl),a
inc hl
djnz bit
ret
.fillsp
dec de
ld a," "
jr fillq+2
.fillq
ld a,"?"
ld (hl),a
inc hl
djnz fillq+2
ret

.illegal
db "%()_=|[];:<>,/\"
.moreil
db "%%",0

.isdot
ld a,b
or a
ret z
push bc
.idlp
dec de
ld a,(de)
cp "."
ld a,b
jr z,pbc
djnz idlp
scf
.pbc
pop bc
ret

.initcb
ld hl,(crsect)
inc h:inc h
ld (ddir),hl
add hl,bc
jr setbuff2

.setbuff
ld (crsect),hl
.setbuff2
ld a,#80
ld (bufstbk),a
ld (bufendbk),a
xor a
ld l,a
ld (bufstrt),hl
ld (bufend),hl
dec h
ld e,h
ld d,a
ld hl,(buftot+1)
sbc hl,de
ld (buffree+1),hl
ld (buffree),a
scr_addr de,72,22
call dechl_k
.showfree
scr_addr de,72,21
ld hl,(buffree+1)
jp dechl_k

.initfs
db #ff			; Currently logged drive 
db 1			; All User Areas
db 0			; Select User Area 0
db "???????????"	; File specification mask

db "*.*         ",#ff	; File specification string (fspec2)

db "   ",#ff		; unumb

db "   ",#ff		; tuser

dw 0			; userl, issort

db #c3,0,0		; rwcal
db #c3			; fordo

.unknown
db "UNKNOWN",#ff

.numforms equ 25

;Use MS800 format block if OFF=1
;Format enable - low nibble is for format - bit 0=ss40, bit 1=ds40, bit2=ss80, bit3=ds80
.ms800f
db #71,#04,#c7,#fc,#8a,"MS800",#ff	;MS800 format	(bit 7 of sector count = extra track)

.forms					;first sect, BSH, LSB of DSM
					;form enable, sects

db #91,#04,#c7,#fc,10,#c6,"80",#ff	;1. PARADOS 80
db #81,#03,#cc,#ff,#8a,#c6,"41",#ff	;2. PARADOS 41
db #a1,#04,#c7,#fa,10,#c6,"40D",#ff	;3. PARADOS 40D
db #01,#04,#67,#f8,9,#c2,"1",#ff	;4. ROMDOS D1
db #21,#04,#67,#f8,9,#c2,"2",#ff	;5. ROMDOS D2
db #11,#04,#8f,#f8,10,#c2,"10",#ff	;6. ROMDOS D10
db #31,#04,#8f,#f8,10,#c2,"20",#ff	;7. ROMDOS D20
db #51,#04,#c7,#fa,10,#c2,"40",#ff	;8. ROMDOS D40
db #71,#04,#c7,#fc,10,"S-DOS",#ff	;9. S-DOS (ROMDOS D80)
.dataf equ $ + 5			; Used to set first track on Verify/Backup
db #c1,#03,#b3,#ff,9,#c4,#c7,#ff	;10. DATA (SS 40)
db #c1,#04,#b3,#2a,9,#c4,#c8,#ff	;11. DATA (DS 40)
db #c1,#04,#b3,#4c,9,#c4,#c9,#ff	;12. DATA (SS 80)
db #c1,#05,#b3,#f8,9,#c4,#ca,#ff	;13. DATA (DS 80)
db #41,#03,#aa,#ff,9,#c3,#c7,#ff	;14. SYSTEM (SS 40)
db #41,#04,#ae,#2a,9,#c3,#c8,#ff	;15. SYSTEM (DS 40)
db #41,#04,#ae,#4c,9,#c3,#c9,#ff	;16. SYSTEM (SS 80)
db #41,#05,#b0,#f8,9,#c3,#ca,#ff	;17. SYSTEM (DS 80)
db #01,#03,#9b,#ff,8,#c5,#c7,#ff	;18. IBM (SS 40)
db #01,#04,#9d,#2a,8,#c5,#c8,#ff	;19. IBM (DS 40)
db #01,#04,#9d,#4c,8,#c5,#c9,#ff	;20. IBM (SS 80)
db #01,#05,#9e,#f8,8,#c5,#ca,#ff	;21. IBM (DS 80)
db #01,#03,#ae,#ff,9,#d5,#c7,#ff	;22. PCW (SS 40)
db #01,#04,#64,#f8,9,#d5,#ca,#ff	;23. PCW (DS 80)
db #10,#03,#cc,#ff,#8a,#d0,#ff		;24. ULTRAFORM
db #01,#05,#b0,#f8,9,#d4,#ff		;25. VORTEX

db 0

list
.endall
nolist
let tmp1 = #fffd - $
ds tmp1
limit #ffff
list
.ROM_DPB	db DEF_DPB
.ROM_DDB	db DEF_DDB
if2:print "Free Space: $tmp1":endif
db checksum(#c000,#3fff)
nolist
if plus
  list
  save "ParaDOS 1-2+.ROM",#c000,#4000
  nolist
else
  list
  save "ParaDOS 1-2.ROM",#c000,#4000
  nolist
endif
