.DDB_A_SS_HEAD     equ #80	; Head to Use 0 or 1
.DDB_A_DOUBLE_STEP equ #40	; 0 for Single-Step, 1 for Double-Step
.DDB_A_80_TRACK    equ #20	; 0 for 40 Track, 1 for 80 Track
.DDB_A_DOUBLE_SIDE equ #10	; 0 for Single-Sided, 1 for Double-Sided

.DDB_B_SS_HEAD     equ #08	; Head to Use 0 or 1
.DDB_B_DOUBLE_STEP equ #04	; 0 for Single-Step, 1 for Double-Step
.DDB_B_80_TRACK    equ #02	; 0 for 40 Track, 1 for 80 Track
.DDB_B_DOUBLE_SIDE equ #01	; 0 for Single-Sided, 1 for Double-Sided

.DPB_VORTEX_PCW    equ #10	; 0 for D1/IBM, 1 for Vortex/PCW
.DPB_ULTRAFORM     equ #08	; 0 for ROMDOS D10, 1 for Ultraform
.DPB_IBM           equ #04	; 0 for ROMDOS D1/Vortex, 1 for IBM/PCW
.DPB_ELECTRO       equ #02	; 0 Disable, 1 Enable Electro Formats
.DPB_DDB_LOCK      equ #01      ; 0 Unlock, 1 Lock DDB to not use format specifier

.RAM_DDB           equ #baff
.RAM_DPB           equ #bafe
.RAM_LOCK          equ #bafa

.DRV_A_DPH_PTR     equ #be40
.DRV_A_DPB_PTR     equ #be42

.FDC_BUFF_ST0      equ #be4c
.FDC_BUFF_ST1      equ #be4d
.FDC_BUFF_ST2      equ #be4e
.FDC_BUFF_C        equ #be4f
.FDC_BUFF_H        equ #be50
.FDC_BUFF_R        equ #be51
.FDC_BUFF_N        equ #be52

.AMSDOS_RETRIES    equ #be66
.TICKER_ADDRESS    equ #be71
.TICKER_ROM_SEL    equ #be73
.DISC_ERR_FLAG     equ #be78
.FDC_AVAILABLE     equ #be7a	; On Plus 00 = No FDC, FF = FDC present
.AMSDOS_RESERVED   equ #be7d

.STEP_RATE         equ #0a

.UNUSED_SECTOR     equ #f1

.scan_cyl          equ #c55d
.scan_curr         equ #c56c
.disc_setup        equ #c5d4
.write_sector      equ #c64e
.format_track      equ #c652
.read_sector       equ #c666

if plus
  .rom_empty1 equ #cdd7
  .rom_empty2 equ #dcf7
  .limit1     equ #ce5c
  .setup_disc equ #c706
  .withretry  equ #c729
  .move_track equ #c792
  .fdc_out    equ #c988
  .motor_on   equ #c9cc
  .ticker     equ #ca38
  .dpb_reset  equ #ca56
  .origsys40  equ #caa9
  .getdrvdpbv equ #cac2
  .getdrvdpb  equ #cac9
  .deiyde     equ #cafe
  .hliyhl     equ #cb05
  .uppercase  equ #cb0c
  .clrdebc    equ #cb15
  .retigncan  equ #cb1e
  .decimal_hl equ #cba0
  .cas_jump   equ #cd94
  .org_drive  equ #ceb9
  .cphlde     equ #dcea
else
  .rom_empty1 equ #dc00
  .limit1     equ #fffd
  .setup_disc equ #c60d
  .withretry  equ #c6ff
  .move_track equ #c763
  .fdc_out    equ #c95c
  .motor_on   equ #c976
  .ticker     equ #c9d6
  .dpb_reset  equ #c9f4
  .origsys40  equ #ca43
  .getdrvdpbv equ #ca5c
  .getdrvdpb  equ #ca63
  .deiyde     equ #ca98
  .hliyhl     equ #ca9f
  .uppercase  equ #caa6
  .clrdebc    equ #caaf
  .retigncan  equ #cab8
  .decimal_hl equ #cb3a
  .cas_jump   equ #cd30
  .org_drive  equ #cdc2
  .cphlde     equ #dbf3
endif

.dalloc		equ #a900
.sorted		equ #aa00
.sortedx	equ #ab00
.dalloch	equ #a9
.sortedh	equ #aa
.sortedxh	equ #ab
.winbuff	equ #a360	; 34 x 40 byte buffer window background on dmess
.formbuff	equ #a300
.vbuff		equ #aeb0

nocode
org #be80

list
.ramlist 	ds 34		; List of available RAM banks
.keystate	db 0		; 0 - normal, 1 - shift, 2 - control
.formdesc	dw 0		; Address of format description
.sect1		db 0		; First sector from track 0
.sect2		db 0		; First sector from track 1
.sect3		db 0		; Last sector + 1 (first + spt)
.fspec		db 0		; Logged drive (#ff = none, 0 = A, 1 = B)
		db 0		; All User Areas (0 = single User Area, 1 = All)
		db 0		; Selected User Area
		ds 11		; Converted file specification mask (*.* -> ???????????)
.fspec2		ds 13		; Raw file specificatio mask (11 + 1 + #ff byte)
.unumb		ds 4		; Contains displayed User Number (or All)
.tuser		ds 4		; Holds entered destination User
.userl		db 0		; Entered User length (0 for All)
.issort		db 0		; Sorted (0 = sorted, #ff = unsorted)
.rwcal		ds 3		; Routine for read/write/calibrate
.fordo		ds 3		; Routine for file loop
.dire		db 0
.dirsc		db 0
.dsm		dw 0
.exmsk		db 0
.blmsk		db 0
.entries	dw 0
.files		dw 0
.lastf		dw 0
.lastf2		dw 0
.firstf		db 0
.totalk		dw 0
.kused		dw 0
.curpos		dw 0
.maxcp		dw 0
.curadr		dw 0
.ktagged	dw 0
.ftagged	dw 0
.xypos		dw 0
.doit		db 0
.numadr
.attset		dw 0
;.obaff
.destuser	db 0
.verror
.alloww		db 0
.numfr		db 0
.scrls		db 0
.basea		dw 0
.basef		db 0
.currf		db 0
.resert		db 0
.verform	db 0
.formdrv	db 0
.oldwin		ds 4
.oldpen		db 0
.oldcurs	dw 0
.wintop		dw 0
.winwid		db 0

nolist

org #3c

list
.tempf2		ds 13
.tempf		ds 13
.savedpb	ds #3a
.recaddr	dw 0
.blkoff		dw 0
.sectoff	db 0
.trksec		dw 0
.rfname		dw 0
.buftot		ds 3
.buffree	ds 3
.bufstrt	dw 0
.bufstbk	db 0
.bufend		dw 0
.bufendbk	db 0
.ddir		dw 0
.crsect		dw 0
.maxtrk
.rfptr		db 0	; This byte and the next used (was dw)
.fmtspt		db 0
.dlogged	db 0
.endddir	dw 0
.ffile		db 0	;Leave this
.wfptr		dw 0	;group of 5 bytes
.wblks		dw 0	;intact.
.wrecad		dw 0
.wblkof		dw 0
.wsectof	db 0
.writeyn	db 0
.wextent	db 0
.wfloc		dw 0
.writeent	dw 0
.wtrksec	dw 0
.wclose		db 0
.werror		db 0
.wrtany		db 0
.needent	db 0
.ramaddr	dw $ + endcurs - ramcode
nolist

code
